function facebookConnect(){
	isFb = false;
	var fbUsername = null;
	var enableFB = false;
	fbUserId = null;
	fbShowPic = false;
}

facebookConnect.prototype.addFbShareButton = function(){
	$('#shareButton').hide();
	$('#shareMsg').hide();

	if(enableFB == true && fbUserId != null){
		var me = this;
		var ACTION_TABLE = [];
		ACTION_TABLE['9'] = [];
		ACTION_TABLE['9']['41'] = IDS_LANGUAGE.eow['ran'];
		ACTION_TABLE['9']['42'] = IDS_LANGUAGE.eow['biked'];
		ACTION_TABLE['9']['43'] = IDS_LANGUAGE.eow['ran'];
		ACTION_TABLE['9']['44'] = IDS_LANGUAGE.eow['hiked'];
		ACTION_TABLE['9']['45'] = IDS_LANGUAGE.eow['hiked'];
		ACTION_TABLE['9']['22'] = IDS_LANGUAGE.eow['ran'];
		ACTION_TABLE['9']['25'] = IDS_LANGUAGE.eow['ran'];
		ACTION_TABLE['9']['28'] = IDS_LANGUAGE.eow['biked'];
		ACTION_TABLE['9']['31'] = IDS_LANGUAGE.eow['biked'];
	
		var action = IDS_LANGUAGE.eow['excercised'];
		
		var manufacturer = workoutdataObj.get_csafe_version_manufacturer();
		var model = workoutdataObj.get_csafe_version_model();
		if (ACTION_TABLE[manufacturer])
			action = ACTION_TABLE[manufacturer][model] || action;

		var locationName = machineObj.getLocationName();

		if (locationName == ""){
			locationName =  IDS_LANGUAGE.eow['defaultLocation'];
		}

		var fbMsg = "I just " + action + " " + locationName;

		$('#shareButton').show();
		$('#shareMsg').show();
		$('#shareButton').html(IDS_LANGUAGE.eow["shareBtn"]);
		$('#shareMsg').html(fbMsg);
		$('#shareButton').mousedown(function(){
				
			var reqURL = "https://graph.facebook.com/822526117/feed?method=post&access_token=574675062595920|xQxd_ZQt2VrFiX8Hq1FVc1q6JbA&message="+fbMsg;


			var successCallback = function(data){
			console.log("Oh yeah, I just posted some stuff to a facebook wall.");
			$('#shareStatus').html(IDS_LANGUAGE.eow["shareStat"]).css("opacity", "1").fadeIn(456);

			}

			var errorCallback = function(errorThrown){
			console.log("OH SNAP! Somethin' done didn't work right when we tried to talk to Facebook.");
			$('#shareStatus').html(IDS_LANGUAGE.eow["failedStatus"]).css("opacity", "1").fadeIn(456);

			}

			var continueCallback = null;
			var reqTimeout = null;
			var reqType = null;
			var reqDataType = "json";

			dirtyHarry(reqURL, successCallback, errorCallback, continueCallback, reqTimeout, reqType, reqDataType);

		});
	}
}


facebookConnect.prototype.isFbUser = function(){

	if(enableFB != true){
		$('#registerFb').hide();
	}

	if(enableFB == true){
		$('#registerFb').show();
		if(fbUserId == null){
			$('#profilePic').html('<img src="views/settings/images/avatar.png" />');
			$('#profilePic span').html('Lifescape User');
			$('#facebookConnectButton').addClass('disabled');
		}else{
		
		var reqURL = "https://graph.facebook.com/"+fbUserId;

		var successCallback = function(data){
			var fbUsername = data.username;
			var userId = data.id;
			var fb_picture = fbShowPic;
			fbConnect.updateUserProfile(userId, fbUsername, fb_picture);
		}

		var errorCallback = function(errorThrown){
			console.log("OH SNAP! Somethin' done didn't work right when we tried to talk to Facebook.")
		}

		var continueCallback = null;
		var reqTimeout = null;
		var reqType = null;
		var reqDataType = "json";

		dirtyHarry(reqURL, successCallback, errorCallback, continueCallback, reqTimeout, reqType, reqDataType);
		}
	}
}


//Initialize Facebook API
facebookConnect.prototype.init = function initFB(enableFB){
	if(enableFB == true){
		this.buildFbLogin();
		this.fbPopReg();
	}
}
//Call the Facebook API to pull user info
facebookConnect.prototype.getFbUserInfo = function fbUserInfo(finalToken){
	console.log('calling getFBUserInfo');
	var reqURL = "https://graph.facebook.com/me?access_token="+finalToken;

	var successCallback = function(data){
		userEmailAddress = data.email;
		(data.gender == 'male') ? userGender = 'M' : userGender = 'F';		
		userDOB = data.birthday.toString();
		fbUserId = data.id;
		fbConnect.validFbEmail();
		console.log(data);
	}

	var errorCallback = function(errorThrown){
		writeLog("info",'FACEBOOK CONNECT ERROR: Not able to access facebook token.');
	}

	var continueCallback = null;
	var reqTimeout = null;
	var reqType = null;
	var reqDataType = "json";

	dirtyHarry(reqURL, successCallback, errorCallback, continueCallback, reqTimeout, reqType, reqDataType);
};

facebookConnect.prototype.updateUserProfile = function(theuser, fbUser, fbpicture){
	
	console.log("Update User Profile Called: "+fbUserId+"--"+fbpicture);

	var profilePicture = '<img id="" src="http://graph.facebook.com/'+theuser+'/picture?type=normal" /><span>'+fbUser+'</span>';	

		if(fbShowPic == 'false' || fbShowPic == false){
			$('#profilePic').html('<img src="views/settings/images/avatar.png" /><span>'+fbUser+'</span>');
			$('#myProfilePicture').html('<img src="views/settings/images/avatar.png" />');
			$('#toggleUserPic').html('Show');
			$('#toggleUserPic').addClass('disabled');
		}else{
		$('#profilePic').html(profilePicture);
			$('#toggleUserPic').html('Hide');
			$('#toggleUserPic').removeClass('disabled');	
		}

		
};

facebookConnect.prototype.storeFbInfo = function(theuser){
		var file = "<datastore user_id='"+athleteObj.get_user_id()+"' machine_id='"+configObj.getMid()+"' type='netpulse' ><store name='fbuid' value='"+theuser+"' /><store name='showfbpic' value='"+fbShowPic+"' /></datastore>";
		writeToFile('/netpulse/upload/datastore.xml', file);
		console.log('store fb info called');
		
}

facebookConnect.prototype.updateFbUserInfo = function fbUserInfoUpdate(finalToken){

	var reqURL = "https://graph.facebook.com/me?access_token="+finalToken;

	var successCallback = function(data){
		
		fbUserId = data.id; 
		fbUsername = data.username;
		console.log('Facebook User ID updated to: '+fbUserId);
		console.log(data);
		viewManager.show('settings');
		fbConnect.updateUserProfile(fbUserId, fbUsername);
		fbConnect.storeFbInfo(fbUserId);
	}

	var errorCallback = function(errorThrown){
		writeLog("info",'FACEBOOK CONNECT ERROR: Not able to access facebook token.');
	}

	var continueCallback = null;
	var reqTimeout = null;
	var reqType = null;
	var reqDataType = "json";

	dirtyHarry(reqURL, successCallback, errorCallback, continueCallback, reqTimeout, reqType, reqDataType);
}

//validate the email addres from Facebook
facebookConnect.prototype.validFbEmail = function validateFbEmail(){
	// Test the entry against the server
	var urlString = machineObj.getServerLocation() + "n5ipicture.jsp?email=" + userEmailAddress + "&mid=" + configObj.getMid();

	var successCallback = function(responseXML){

		if (responseXML.getElementsByTagName('response')[0].getAttribute("pic") == "NOT FOUND") {
			viewManager.activeObject.slidingBox.scrollJump(1);
			$('#iKB').hide();

		}
		else{ 
			$('#fb').hide();
			showModal(IDS_LANGUAGE.register["emailhastaken"], 3000);
			setTimeout(function(){
				$('#fb').show();
			}, 3000);
		}
	};

	var errorCallback = function(data, textStatus, errorThrown){
		var errorString = (textStatus == "timeout") ? IDS_LANGUAGE.login["NetworkCommunicationError"] : IDS_LANGUAGE.register["regproblemString"] + "<br />" +IDS_LANGUAGE.register["anotherTime"];
		
		userEmailAddress = null;
		showModal(errorString, 3000);
	};

	dirtyHarry(urlString, successCallback, errorCallback);			
}
//change the core populate function to support facebook data
facebookConnect.prototype.fbPopReg = function populateFbRegSummary(){
	if(isFb == true){
		registerObj.prototype.populateRegistration = function (e){  

			$('#summaryUserId').html(String(this.userId));
			$('#summaryEmail').html(userEmailAddress);
			$('#summaryWeight').html(this.userWeight);
			$('#summaryDOB').html(userDOB);

			var gender = (userGender == 'M') ?   IDS_LANGUAGE["Male"] : IDS_LANGUAGE["Female"]; 
			$('#summaryGender').html(gender);
		}
	}else{
		registerObj.prototype.populateRegistration = function (e){  

			$('#summaryUserId').html(String(this.userId));
			$('#summaryEmail').html(this.userEmailAddress);
			$('#summaryWeight').html(this.userWeight);
			$('#summaryDOB').html(this.userDOB);

			var gender = (this.userGender == 'M') ?   IDS_LANGUAGE["Male"] : IDS_LANGUAGE["Female"]; 
			$('#summaryGender').html(gender);
		}
	}
}
// Build the Facebook Login Window and Keyboard
facebookConnect.prototype.buildFbLogin = function buildFbLogin(){
		var $fb = $('div#fb');
		var me = this;

		$buildFbLoginObject = '<object id="auth_facebook" class="auth" type="text/html" tabindex="1" url="https://www.facebook.com/dialog/oauth?client_id=574675062595920&display=popup&response_type=token&redirect_uri=https://www.facebook.com/connect/login_success.html&scope=publish_actions,email,user_birthday" width="800" height="300"><param name="onurlchange" value="getFbToken"></object>';

		$fbKeyboard = ('<div id="keyboard"><object id="iKB" type="keyboard" target="auth_facebook" style="visibility:show; display:block;" /></div>');
		if(isFb == true){
			$fb.append($buildFbLoginObject);
			$fb.append($fbKeyboard);
		}
}
//set up pictures and usernames if the user is a facebook user
facebookConnect.prototype.enableFbUser = function() {
	var me = this;

	$('#toggleUserPic').mousedown(function(){
		$("#toggleUserPic").toggleClass('disabled');
		if($("#toggleUserPic").attr('class') == 'toggle'){
			$('#myProfilePicture').html('<img src="http://graph.facebook.com/'+fbUserId+'/picture?type=normal" />');
			$('#toggleUserPic').html('Hide');
			var file = "<datastore user_id='"+athleteObj.get_user_id()+"' machine_id='"+configObj.getMid()+"' type='netpulse'><store name='showfbpic' value='true' /></datastore>";
			writeToFile('/netpulse/upload/datastore.xml', file);
			fbShowPic = true;

		}else{
			$('#myProfilePicture').html('<img src="views/settings/images/avatar.png" />');
		$('#toggleUserPic').html('Show');
		var file = "<datastore user_id='"+athleteObj.get_user_id()+"' machine_id='"+configObj.getMid()+"' type='netpulse'><store name='showfbpic' value='false' /></datastore>";
		writeToFile('/netpulse/upload/datastore.xml', file);
		fbShowPic = false;

		}
	});

	if(fbUserId != null){
		$('#myProfilePicture').html('<img src="http://graph.facebook.com/'+fbUserId+'/picture?type=normal" />');
		$('#toggleUserPic').html('Hide');
		$('#facebookConnectButton').html('Disable');
	}else{
		$('#profileSection').hide();
		$('#facebookConnectButton').html('Enable');

	}

	if(enableFB != true){
		$('#facebookConnectButton').hide();
		$('#facebookEdit').hide();
		$('#profileSection').hide();
	}

	$fbLoginObject = '<object id="auth_facebook" class="auth" type="text/html" tabindex="1" url="https://www.facebook.com/dialog/oauth?client_id=574675062595920&display=popup&response_type=token&redirect_uri=https://www.facebook.com/connect/login_success.html&scope=publish_actions,email,user_birthday" width="800" height="300"><param name="onurlchange" value="updateFbToken"></object>';

	$fbKeyboard = ('<object id="iKB" type="keyboard" target="auth_facebook" style="visibility:show; display:block; width:1159px; height:289px;" />');

	$('#facebookConnectButton').mousedown(function(){
		if($('#facebookConnectButton').attr('class') == 'toggle disabled'){
			$('#facebookConnectButton').removeClass('disabled');
			$('#accountSection').hide();
			$('#gigyaContainer').show();
			$('#gigyaContainer').append($fbLoginObject);
			$('#gigyaContainer #underlay').append($fbKeyboard);
		}else{
			$('#facebookConnectButton').html('Enable');
			$('#facebookConnectButton').addClass('disabled');
			$('#profileSection').hide();
			$('#myProfilePicture').html('<img src="views/settings/images/avatar.png" />');
			var file = "<datastore user_id='"+athleteObj.get_user_id()+"' machine_id='"+configObj.getMid()+"' type='netpulse'><unstore name='fbuid'/> <unstore name='showfbpic' /></datastore>";
			writeToFile('/netpulse/upload/datastore.xml', file);
			fbUsername = null;
			fbUserId = null;
		}
	});
}

//Find and extract the Facebook access token
function getFbToken(url){

	$currentURL = [];

	$currentURL.push(url);

	for (var i = 0; i < $currentURL.length; i++) {

		var word = 'access_token';
		var regex = new RegExp( '\\b' + word + '\\b' );

		var result = regex.test( $currentURL );

		if(result == true){
				$('div#fb').hide();

			var fbAccessToken = $currentURL[i];
			var fbTokenString = fbAccessToken;
			var fbTokenSplit = fbTokenString.split("#access_token=");
			var splitToken = fbTokenSplit[1];
			var almostThere = splitToken.split("&");
			var finalToken = almostThere[0];
			//send the token to Favebook API call
			fbConnect.getFbUserInfo(finalToken);
		}
	}
}

function updateFbToken(url){
		$currentURL = [];

	$currentURL.push(url);

	for (var i = 0; i < $currentURL.length; i++) {

		var word = 'access_token';
		var regex = new RegExp( '\\b' + word + '\\b' );

		var result = regex.test( $currentURL );

		if(result == true){
				$('div#fb').hide();

			var fbAccessToken = $currentURL[i];
			var fbTokenString = fbAccessToken;
			var fbTokenSplit = fbTokenString.split("#access_token=");
			var splitToken = fbTokenSplit[1];
			var almostThere = splitToken.split("&");
			var finalToken = almostThere[0];
			fbConnect.updateFbUserInfo(finalToken);
		}
	}
}
// ...and I'm spent.