/*---------------------------------------------------------------------
	On Demand Script (True) | true/views/onDemand/js.js
---------------------------------------------------------------------*/

//  OnDemand View Object
function trueOndemandObj(name, type, vm, superClass) {
	var me = this;
	me.name = name;
	me.type = type;
	me.vm = vm;
	me.superClass = superClass;
	me.core = (new (window[superClass])(me.name, me.type, me.vm));
	me.itemsPerPage = 8;
	me.volume = machineObj.getVolumeLevel();
	me.startTime = 0;
	me.endTime = 0;
	me.videoPlaying = false;
	me.disabled = false;

	return me;
}

trueOndemandObj.prototype = new ondemandObj;

// Left empy to remove button labels
trueOndemandObj.prototype.updateScrollButtonLabels = function() {};

trueOndemandObj.prototype.play = function trueOndemandObjPlay() {
	var me = this;
    
	if (me.errorTimeout)
		clearTimeout(me.errorTimeout);
	
	var currentShow = me.slideBox.data.items[me.slideBox.chosenItems[0]].items[me.slideBox.chosenItems[1]];
	var currentEpisode = me.slideBox.chosenItems[2];

	watchObj.target = {
		"parentView" : me.vm.currentView,
		"channel" : currentShow, // List of media items to play
		"episode" : currentEpisode // Start with the first video
	};
	me.vm.show("watch");
};

trueOndemandObj.prototype.getBrandedMenuData = function trueOndemandObjGetBrandedMenuData() { /* HIDE MENU-ADS FOR THIS SKIN */ };
trueOndemandObj.prototype.insertBrandedMenuItem = function trueOndemandObjInsertBrandedMenuItem() { /* HIDE MENU-ADS FOR THIS SKIN */ };

/*-------------------------------------------------------------------*/
//@ sourceURL=true/views/onDemand/js.js