#!/bin/bash
if [ -n "$NETPULSE_ROOT" ] ; then
    echo "NETPULSE_ROOT is set to $NETPULSE_ROOT"
else
    CWD=`pwd`
    DIR=`dirname $CWD`
    export NETPULSE_ROOT=${DIR} 
fi
export LD_LIBRARY_PATH=${NETPULSE_ROOT}/lib
export QT_PLUGIN_PATH=${NETPULSE_ROOT}/plugins
killall -KILL gui oemsender > /dev/null 2>/dev/null
if [ -f ${NETPULSE_ROOT}/bin/oemsender ]; then
    ${NETPULSE_ROOT}/bin/oemsender &
fi
${NETPULSE_ROOT}/bin/master
