@echo off
REM ******************************************************
REM  Not all Windows have a 'sleep' command/function
REM  A simple solution is to ping a non-existent ip with a
REM  time (in ms) and a count of 1 (-n 1)
REM ******************************************************
REM ping 1.1.1.1 -n 1 -w 3000 > null

PowerShell.exe -NoProfile -NonInteractive -ExecutionPolicy unrestricted -Command "& c:\apps\netpulse\bin\stick-install.ps1"

echo Set-ExecutionPolicy Unrestricted
REM Unrestrict the execution policy for the current user. Otherwise npinstall.ps1 will not be allowed to execute
START /B CMD /C CALL %SystemRoot%\\system32\\WindowsPowerShell\\v1.0\\powershell.exe Set-ExecutionPolicy Unrestricted -Scope CurrentUser
IF %ERRORLEVEL% NEQ 0 GOTO ERROR

echo execute stick-install.ps1
REM stick-install.ps1 will iterate over all of the physical drives and look for
REM a npinstall.ps1 file. If found, the npinstall.ps1 file will be executed
START /B CMD /C CALL %SystemRoot%\system32\WindowsPowerShell\v1.0\powershell.exe -Command "c:\apps\netpulse\bin\stick-install.ps1"
IF %ERRORLEVEL% NEQ 0 GOTO ERROR

echo Set-ExecutionPolicy Restricted -Scope CurrentUser
REM Set the CurrentUser's execution policy back to restricted
START /B CMD /C CALL %SystemRoot%\system32\WindowsPowerShell\v1.0\powershell.exe Set-ExecutionPolicy Restricted -Scope CurrentUser
IF %ERRORLEVEL% NEQ 0 GOTO ERROR

REM No Error, so skip over the :ERROR tag and go to DONE
IF %ERRORLEVEL% EQU 0 GOTO DONE

:ERROR
echo Failed with error: %errorlevel%

:DONE
echo Complete!
