//////////////////////////////////////////////////////////////////////////////// 
// 
// NOTE!!!! 
// Before you add a new variable, MAKE SURE THAT IT DOESN'T ALREADY EXIST! 
// 
 
// Associative Array for all text. This will allow us to create a different 
// file for a different language in the future 
var IDS_LANGUAGE = []; 
 
// Welcome Message 
IDS_LANGUAGE["defaultUser"] = "Netpulse User"; 
IDS_LANGUAGE["helloUser"] = "환영합니다, %s!"; 
IDS_LANGUAGE["welcome"] = "환영합니다"; 
 
// Attract Page 
IDS_LANGUAGE["quick start"] = "Quick<br/>Start"; 
IDS_LANGUAGE["Select a Workout"] = "Select a<br/>Workout"; 
IDS_LANGUAGE["My Workout"] = "My<br/>Workout"; 
IDS_LANGUAGE["SignIn"] = "가입"; 
IDS_LANGUAGE["GetOnAndGo"] = "Get On and Go!"; 
IDS_LANGUAGE["CusomizeYourExperience"] = "Customize Your Experience"; 
IDS_LANGUAGE["My Workout"] = "My Workout"; 
 
// Terms and Condition 
IDS_LANGUAGE["terms_content"]= "<ol>    <li><p><b>Acceptance of Terms</b></p></li></ol><p>Netpulse, Inc. (&ldquo;Netpulse&rdquo; or the &ldquo;Company&rdquo;, which terms shall include affiliates of Netpulse, Inc.) provides the Netpulse Services (as defined below) to you subject to the following Terms of Service (&ldquo;TOS&rdquo;), which may be updated by the Company from time to time without notice to you.  Netpulse Services includes any services associated with the Company for use by you, including, without limitation, (a) the netpulse.com website, and any related domains or subdomains (collectively, the &ldquo;Site&rdquo;); (b) access and use of the network (the &ldquo;Netpulse Network&rdquo;) of content and exercise-related information through any device, equipment, display or other means of access to the Netpulse Services, whether now in existence or in the future; and (c) use of exercise equipment that contains Netpulse-enabled content or controls, to the extent that such use relates to hardware, software or services provided by Netpulse.</p><p>By accessing and using the Netpulse Services, you accept and agree to be bound by the terms and provision of these TOS.  If you do not agree to these TOS, you should stop use of the Netpulse Services. These TOS include the Netpulse Privacy Policy located at www.netpulse.com.  In addition, any rules, guidelines or additional terms that may be presented to you in the course of your use of the Netpulse Services are incorporated by reference into these TOS.</p><ol start=2>    <li><p><b>Registration and Account Information</b></p></li></ol><p>You represent that you are a natural person with the legal capacity to form a binding contract and be subject to these TOS under the laws of any applicable jurisdiction. You also agree that you will provide true, accurate, current and complete information about yourself as prompted by the Netpulse Service&rsquo;s registration form, with updates, as applicable. If you provide any information that is untrue, inaccurate, not current or incomplete, or Netpulse has reasonable grounds to suspect that such information is untrue, inaccurate, not current or incomplete, Netpulse has the right to suspend or terminate your account and refuse to provide you any further access to any portion of the Netpulse Services.   You understand that through your use of the Netpulse Services, you consent to the collection and use, as set forth in the Netpulse privacy policy, of this information, including the transfer of this information outside your applicable jurisdiction to other countries for storage, processing and use by Netpulse and its affiliates.</p><p>You are responsible for maintaining the confidentiality of the password and account name or ID your register under, and are fully responsible for all activities that occur under your account. The Company is not liable for any failure on your part to comply with the foregoing.  You agree to immediately notify Netpulse of any unauthorized use of your password or account or any other breach of security.</p><ol start=3>    <li><p><b>Health Disclaimer</b></p></li></ol><p>The Netpulse Services and the Site may provide physiological data about your body along with information applications and content published over the Internet and are intended only to assist you and other users with respect to such user&rsquo;s personal health, fitness and wellness efforts. Netpulse is not a medical organization and the Company does not and cannot give you medical advice or diagnoses. Nothing transmitted or contained in the Netpulse Services, the Site or through the Netpulse Network should be construed as medical advice or a diagnosis. Any data or reports generated by through use of the Netpulse Services should not be interpreted as a substitute for physician consultation, evaluation, or treatment. The Company urges you to seek the advice of a qualified physician before beginning any health, fitness &amp; wellness related effort or regimen.</p><ol start=4>    <li><p><b>Content and Conduct</b></p></li></ol><p>You understand that all information, data, text, software, music, sound, photographs, graphics, video, messages, tags, or other materials (&ldquo;Content&rdquo;), whether publicly posted or privately transmitted, are the sole responsibility of the person from whom such Content originated (except that anything disclaimed under Section 3 above is not the responsibility of Netpulse). You understand that by using the Netpulse Services, you may be exposed to Content that is offensive or objectionable. Under no circumstances will Netpulse be liable in any way for any Content, including, but not limited to, any errors or omissions in any Content, or any loss or damage of any kind incurred as a result of the use of any Content posted, emailed, transmitted or otherwise made available via the Netpulse Services.</p><p>You agree you shall not use the Netpulse Services to:</p><ol>    <ol>        <li><p>upload, post,        email, transmit or otherwise make available any Content that is        unlawful, harmful, threatening, abusive, harassing, tortious,        defamatory, vulgar, obscene, libelous, invasive of another&rsquo;s        privacy, hateful, or racially, ethnically or otherwise        objectionable; upload, post, email, transmit or otherwise make        available any Content that infringes any patent, trademark, trade        secret, copyright, privacy, publicity or other proprietary rights        of any party;</p></li>        <li><p>upload, post, email, transmit or        otherwise make available any Content that you do not have a right        to make available under any law or under contractual or fiduciary        relationships (such as inside information, proprietary and        confidential information learned or disclosed as part of employment        relationships or under nondisclosure agreements);</p></li>        <li><p>upload, post, email, transmit or        otherwise make available any unsolicited or unauthorized        advertising, promotional materials, &ldquo;junk mail,&rdquo;        &ldquo;spam,&rdquo; &ldquo;chain letters,&rdquo; &ldquo;pyramid        schemes,&rdquo; or any other form of solicitation.        </p></li>        <li><p>forge headers or otherwise        manipulate identifiers in order to disguise the origin of any        Content transmitted through the Netpulse Services or the Netpulse        Network;</p></li>        <li><p>upload, post, email, transmit or        otherwise make available any material that contains software        viruses, &ldquo;Trojan horses&rdquo; or any other computer code,        files or programs designed to interrupt, destroy or limit the        functionality of any computer software or hardware or        telecommunications equipment;</p></li>        <li><p>interfere with or disrupt the        Netpulse Services or servers or networks connected to the Netpulse        Services, or disobey any requirements, procedures, policies or        regulations of networks connected to the Netpulse Services,        including using any device, software or routine to bypass our robot        exclusion headers;</p></li>        <li><p>intentionally or unintentionally        violate any applicable local, state, national or international law,        including, but not limited to, regulations promulgated by the U.S.        Securities and Exchange Commission, any rules of any national or        other securities exchange, including, without limitation, the New        York Stock Exchange, the American Stock Exchange or the NASDAQ, and        any regulations having the force of law;</p></li>        <li><p>impersonate any person or entity,        or falsely state or otherwise misrepresent your affiliation with a        person or entity;</p></li>        <li><p>&ldquo;stalk&rdquo; or otherwise        harass anyone; and/or</p></li>        <li><p>collect or store personal data        about other users in connection with the prohibited conduct and        activities set forth in paragraphs a through m above.</p></li>    </ol></ol><p>You acknowledge, consent and agree that Netpulse may access, preserve and disclose your account information if required to do so by law or in a good faith belief that such access preservation or disclosure is reasonably necessary to: (i) comply with legal process; (ii) enforce these TOS (iii) respond to your requests for customer service; or (v) protect the rights, property or personal safety of Netpulse, its users or the public.</p><p>You understand that the Netpulse Services and software embodied within the Netpulse Services may include security components that permit digital materials to be protected, and that use of these materials is subject to usage rules set by Netpulse and/or content providers who provide content to the Netpulse Services. You may not attempt to override or circumvent any of the usage rules embedded into the Netpulse Services. Any unauthorized reproduction, publication, further distribution or public exhibition of the materials provided on the Netpulse Services, in whole or in part, is strictly prohibited.</p><ol start=5>    <li><p><b>Interstate    and International Nature of the Netpulse Services</b>    </p></li></ol><p>You acknowledge that in using the Netpulse Services you will be causing communications to be sent through Netpulse&rsquo;s computer networks, portions of which are located in California and other locations in the United States and portions of which may be located abroad. As a result, and also as a result of Netpulse&rsquo;s network architecture and business practices and the nature of electronic communications, even communications that seem to be intrastate in nature can result in the transmission of interstate communications regardless of where you are physically located at the time of transmission. Accordingly, you acknowledge that use of the Netpulse Services results in interstate data transmissions.</p><ol start=6>    <li><p><b>Contributions    to Netpulse</b></p></li></ol><p>By submitting ideas, suggestions, documents, and/or proposals (&ldquo;Contributions&rdquo;) to Netpulse through the Site, feedback mechanisms or otherwise, you acknowledge and agree that: (a) your Contributions do not contain confidential or proprietary information; (b) Netpulse is not under any obligation of confidentiality, express or implied, with respect to the Contributions; (c) Netpulse shall be entitled to use or disclose (or choose not to use or disclose) such Contributions for any purpose, in any way, in any media worldwide; (d) Netpulse may have something similar to the Contributions already under consideration or in development; (e) your Contributions automatically become the property of Netpulse without any obligation of Netpulse to you; and (f) you are not entitled to any compensation or reimbursement of any kind from Netpulse under any circumstances.</p><ol start=7>    <li><p><b>Indemnity</b></p></li></ol><p>You agree to indemnify and hold Netpulse and its subsidiaries, affiliates, officers, agents, employees, partners and licensors harmless from any claim or demand, including reasonable attorneys&rsquo; fees, made by any third party due to or arising out of your use of the Netpulse Services, your connection to the Netpulse Services, your violation of these TOS, or your violation of any rights of another.</p><ol start=8>    <li><p><b>Modification    or Termination of Netpulse Services</b></p></li></ol><p>Netpulse reserves the right at any time, in its sole discretion, without notice, to modify or discontinue, temporarily or permanently, any part of the Netpulse Services or to terminate, limit your access to or suspend your Netpulse account and access to the Netpulse Services for any reason. You agree that the Company shall not be liable to you or to any third party for any modification, suspension or discontinuance of any part of the Netpulse Services, or for any termination, limit to access or suspension of your Netpulse account.</p><ol start=9>    <li><p><b>Advertisers</b></p></li></ol><p>Your dealings with, or participation in promotions of, advertisers or other third parties found on or through the Netpulse  Services, including payment and delivery of related goods or services, and any other terms, conditions, warranties or representations associated with such dealings, are solely between you and such advertiser or third party. You agree that Netpulse shall not be responsible or liable for any loss or damage of any sort incurred as the result of any such dealings with advertisers or third parties, or as the result of the presence of such advertisers on the Netpulse Network or through the Netpulse Services.</p><ol start=10>    <li><p><b>Links to    Third Parties</b></p></li></ol><p>The Netpulse Services may provide, or third parties may provide, links to other websites or resources. You acknowledge and agree that Netpulse is not responsible for the availability of such external sites or resources, and does not endorse and is not responsible or liable for any Content, advertising, products or other materials on or available from such sites or resources. You further acknowledge and agree that Netpulse shall not be responsible or liable, directly or indirectly, for any damage or loss caused or alleged to be caused by or in connection with use of or reliance on any such Content, goods or services available on or through any such site or resource.</p><ol start=11>    <li><p><b>Netpulse&rsquo;s    Proprietary Rights</b></p></li></ol><p>You acknowledge and agree that the Netpulse Services, any necessary software used in connection with the Netpulse Services and Netpulse Network (&ldquo;Software&rdquo;) and Content provided through the Netpulse Services contain proprietary and confidential information that is protected by applicable intellectual property and other laws. You further acknowledge and agree that Content contained in advertisements or information presented to you through the Netpulse Services or by advertisers is protected by copyrights, trademarks, service marks, patents or other proprietary rights and laws. Except as expressly permitted by applicable law or as authorized by Netpulse or the applicable licensor (such as an advertiser), you agree not to modify, rent, lease, loan, sell, distribute, transmit, broadcast, publicly perform or create derivative works based on the Netpulse Services, such Content or the Software, in whole or in part.</p><p>Netpulse grants you a personal, non-transferable and non-exclusive right and license to use the object code of its Software on a single computer; provided that you do not (and do not allow any third party to) copy, modify, create a derivative work from, reverse engineer, reverse assemble or otherwise attempt to discover any source code, sell, assign, sublicense, grant a security interest in or otherwise transfer any right in the Software. You agree not to modify the Software in any manner or form, nor to use modified versions of the Software, including (without limitation) for the purpose of obtaining unauthorized access to the Netpulse Services.</p><p>You agree that all of Netpulse&rsquo;s trademarks, trade names, service marks and other Netpulse logos and brand features, and product and service names are trademarks and the property of Netpulse Inc. Without Netpulse&rsquo;s prior permission, you agree not to display or use in any manner the Netpulse Marks.</p><ol start=12>    <li><p><b>Disclaimer    of Warranties</b></p></li></ol><p>YOU EXPRESSLY UNDERSTAND AND AGREE THAT:</p><ol>    <ol>        <li><p>YOUR USE OF        THE NETPULSE SERVICES AND SOFTWARE ARE AT YOUR SOLE RISK. THE        NETPULSE SERVICES, THE NETPULSE NETWORK AND SOFTWARE ARE PROVIDED        ON AN &ldquo;AS IS&rdquo; AND &ldquo;AS AVAILABLE&rdquo; BASIS.        NETPULSE AND OFFICERS, EMPLOYEES, AGENTS, PARTNERS AND LICENSORS        EXPRESSLY DISCLAIM ALL WARRANTIES OF ANY KIND, WHETHER EXPRESS OR        IMPLIED, INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF        TITLE, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND        NON-INFRINGEMENT.</p></li>        <li><p>NETPULSE AND ITS OFFICERS,        EMPLOYEES, AGENTS, PARTNERS AND LICENSORS MAKE NO WARRANTY THAT (i)        THE NETPULSE SERVICES OR SOFTWARE WILL MEET YOUR REQUIREMENTS; (ii)        THE NETPULSE SERVICES, NETPULSE NETWORK OR SOFTWARE WILL BE        UNINTERRUPTED, TIMELY, SECURE OR ERROR-FREE; (iii) THE RESULTS THAT        MAY BE OBTAINED FROM THE USE OF THE NETPULSE SERVICES, THE NETPULSE        NETWORK OR SOFTWARE WILL BE ACCURATE OR RELIABLE; (iv) THE QUALITY        OF ANY PRODUCTS, SERVICES, INFORMATION OR OTHER MATERIAL PURCHASED        OR OBTAINED BY YOU THROUGH THE NETPULSE SERVICES OR THE NETPULSE        NETWORK WILL MEET YOUR EXPECTATIONS; AND (v) ANY ERRORS IN THE        SOFTWARE WILL BE CORRECTED.</p></li>        <li><p>ANY MATERIAL DOWNLOADED OR        OTHERWISE OBTAINED THROUGH THE USE OF THE NETPULSE SERVICES, THE        NETPULSE NETWORK OR SOFTWARE IS ACCESSED AT YOUR OWN DISCRETION AND        RISK, AND YOU WILL BE SOLELY RESPONSIBLE FOR AND HEREBY WAIVE ANY        AND ALL CLAIMS AND CAUSES OF ACTION WITH RESPECT TO ANY DAMAGE TO        YOUR COMPUTER SYSTEM, INTERNET ACCESS, DOWNLOAD OR DISPLAY DEVICE,        OR LOSS OF DATA THAT RESULTS FROM THE DOWNLOAD OF ANY SUCH        MATERIAL.</p></li>        <li><p>NO ADVICE OR INFORMATION, WHETHER        ORAL OR WRITTEN, OBTAINED BY YOU FROM NETPULSE OR THROUGH OR FROM        THE NETPULSE SERVICES OR SOFTWARE SHALL CREATE ANY WARRANTY NOT        EXPRESSLY STATED IN THESE TOS.</p></li>        <li><p>A SMALL PERCENTAGE OF USERS        MAY EXPERIENCE EPILEPTIC SEIZURES WHEN EXPOSED TO CERTAIN LIGHT        PATTERNS OR BACKGROUNDS ON A COMPUTER SCREEN OR WHILE USING THE        NETPULSE SERVICE. CERTAIN CONDITIONS MAY INDUCE PREVIOUSLY        UNDETECTED EPILEPTIC SYMPTOMS EVEN IN USERS WHO HAVE NO HISTORY OF        PRIOR SEIZURES OR EPILEPSY. IF YOU, OR ANYONE IN YOUR FAMILY, HAVE        AN EPILEPTIC CONDITION, CONSULT YOUR PHYSICIAN PRIOR TO USING THE        NETPULSE SERVICEs. IMMEDIATELY DISCONTINUE USE OF THE NETPULSE        SERVICES AND CONSULT YOUR PHYSICIAN IF YOU EXPERIENCE ANY OF THE        FOLLOWING SYMPTOMS WHILE USING THE NETPULSE SERVICE: DIZZINESS,        ALTERED VISION, EYE OR MUSCLE TWITCHES, LOSS OF AWARENESS,        DISORIENTATION, ANY INVOLUNTARY MOVEMENT, OR CONVULSIONS.</p></li>    </ol>    <li><p><b>Limitation of Liability</b></p></ol><p>YOU EXPRESSLY UNDERSTAND AND AGREE THAT NETPULSE AND ITS OFFICERS, EMPLOYEES, AGENTS, PARTNERS AND LICENSORS SHALL NOT BE LIABLE TO YOU FOR ANY PUNITIVE, INDIRECT, INCIDENTAL, SPECIAL, CONSEQUENTIAL OR EXEMPLARY DAMAGES, INCLUDING, BUT NOT LIMITED TO, DAMAGES FOR LOSS OF PROFITS, GOODWILL, USE, DATA OR OTHER INTANGIBLE LOSSES (EVEN IF NETPULSE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES), RESULTING FROM: (a) THE USE OR THE INABILITY TO USE THE NETPULSE SERVICE OR THE NETPULSE NETWORK; (b) THE COST OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES; (c) UNAUTHORIZED ACCESS TO OR ALTERATION OF YOUR TRANSMISSIONS OR DATA; (d) STATEMENTS OR CONDUCT OF ANY THIRD PARTY ON THE NETPULSE SERVICE; OR (e) ANY OTHER MATTER RELATING TO THE NETPULSE SERVICE.</p><ol start=14>    <li><p><b>Exceptions    to Disclaimers and Limitations</b></li>    </p></ol><p>SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF CERTAIN WARRANTIES OR THE LIMITATION OR EXCLUSION OF LIABILITY FOR INCIDENTAL OR CONSEQUENTIAL DAMAGES. ACCORDINGLY, SOME OF THE ABOVE LIMITATIONS OF SECTIONS 12 AND 13 MAY NOT APPLY TO YOU.</p><ol start=15>    <li><p>    <b>No Third-Party Beneficiaries</b></p></li></ol><p>You agree that, except as otherwise expressly provided in this TOS, there shall be no third-party beneficiaries to this agreement.</p><ol start=16>    <li><p><b>Notice</b></p></li></ol><p>Netpulse may provide you with notices, including those regarding changes to these TOS, including by but not limited to postings on the Netpulse Services, email, SMS, MMS, text message, regular mail or other reasonable means now known or hereafter developed. Such notices may not be received if you violate these TOS by accessing the Netpulse Services in an unauthorized manner. Your agreement to these TOS constitutes your agreement that you are deemed to have received any and all notices that would have been delivered had you accessed the Netpulse Services in an authorized manner.</p><ol start=17>    <li><p><b>General</b></p></li></ol><p><i>Entire Agreement</i>. These TOS constitutes the entire agreement between you and Netpulse and governs your use of the Netpulse Services, superseding any prior version of these TOS between you and Netpulse with respect to the Netpulse Services. You also may be subject to additional terms and conditions that may apply when you use or purchase certain other Netpulse services, affiliate services, third-party content or third-party software, or communicate with third parties such as advertisers</p><p><i>Choice of Law and Forum</i>. You and Netpulse each agree that these TOS and the relationship between the parties shall be governed by the laws of the State of California without regard to its conflict of law provisions and that any and all claims, causes of action or disputes (regardless of theory) arising out of or relating to these TOS, or the relationship between you and Netpulse, shall be brought exclusively in the courts located in the county of San Francisco, California or the U.S. District Court for the Northern District of California. You and Netpulse agree to submit to the personal jurisdiction of the courts located within the county of San Francisco, California or the Northern District of California, and agree to waive any and all objections to the exercise of jurisdiction over the parties by such courts and to venue in such courts.</p><p><i>Waiver and Severability of Terms</i>. The failure of Netpulse to exercise or enforce any right or provision of these TOS shall not constitute a waiver of such right or provision. If any provision of these TOS is found by a court of competent jurisdiction to be invalid, the parties nevertheless agree that the court should endeavor to give effect to the parties&rsquo; intentions as reflected in the provision, and the other provisions of these TOS remain in full force and effect.</p><p><i>No Right of Survivorship and Non-Transferability</i>. You agree that your Netpulse account is non-transferable and any rights to your Netpulse account or contents within your account terminate upon your death. Upon receipt of a copy of a death certificate, your account may be terminated and all contents therein permanently deleted.</p><p><i>Statute of Limitations</i>. You agree that regardless of any statute or law to the contrary, any claim or cause of action arising out of or related to use of the Netpulse Services or these TOS must be filed within one (1) year after such claim or cause of action arose or be forever barred.</p><p>The section titles in these TOS are for convenience only and have no legal or contractual effect.</p><ol start=18>    <li><p><b>Violations</b></p></li></ol><p>Please report any violations of these TOS to the Company at privacy@netpulse.com.</p><p><br /><br /></p><ol start=19>    <li><p><b>Procedure    for Making Claims of Infringement of Copyrights or other    Intellectual Property</b></p></li></ol><p>The Company respects the intellectual property of others, and asks users to do the same. If you believe that your work has been copied in a way that constitutes copyright infringement, or your intellectual property rights have been otherwise violated, please provide Netpulse with the following information:</p><ol>    <ol>        <li><p>an electronic        or physical signature of the person authorized to act on behalf of        the owner of the copyright or other intellectual property interest;</p></li>        <li><p>a description of the copyrighted        work or other intellectual property that you claim has been        infringed;</p></li>        <li><p>a description of where the        material that you claim is infringing is located through the        Netpulse Services;</p></li>        <li><p>your address, telephone number,        and email address;</p></li>        <li><p>a statement by you that you have        a good faith belief that the disputed use is not authorized by the        copyright owner, its agent, or the law;</p></li>        <li><p>a statement by you, made under        penalty of perjury, that the above information in your notice is        accurate and that you are the copyright or intellectual property        owner or authorized to act on the copyright or intellectual        property owner&rsquo;s behalf.</p></li>        <li><p>Notice        of claims of copyright or other intellectual property infringement        can be delivered as follows:</p></li>    </ol></ol><p>By mail:<br/>Netpulse, Inc.<br/>2331 Third Street<br/>San Francisco, CA 94107</p><p>By e-mail: <u>privacy@netpulse.com</u></p>"; 
 
IDS_LANGUAGE["privacy_content"] = "Privacy Policy applies to all of the products, services and websites offered by Netpulse Inc. (&ldquo;Netpulse,&rdquo; the &ldquo;Company&rdquo;,&rdquo;we,&rdquo; and &ldquo;us,&rdquo; which terms shall include affiliates of Netpulse, Inc.). Please see also the Netpulse Terms of Service. Capitalized terms not otherwise defined in this Privacy Policy shall have the meaning set forth in the Terms of Service.<\/p> <h3>Information we collect and how we use it:<\/h3> <p>You may use some of the Netpulse Services without registration or providing any personal information to Netpulse. In order to provide the full personalized range of Netpulse Services, we may collect the following types of information:<\/p> <ul><li><b>Information you provide<\/b> &ndash; When you sign up for a Netpulse account or other Netpulse Service that requires registration, we may ask you for personal information (such as your name, gender, age, weight, height, other activity and physical data, email address, phone number) and an account password. We may combine the information you submit under your account with information provided through other Netpulse Services or third parties in order to provide you with a better experience and to improve the quality of our services. For certain services, we may give you the opportunity to opt out of combining such information. <\/li> <li> <b>Cookies<\/b> &mdash; When you visit the Site or use the Netpulse Services, we send one or more cookies &ndash; a small file containing a string of characters &ndash; to the device or other device that uniquely identifies you. We use cookies to improve the quality of the Netpulse Services, including for storing user preferences, and tracking user trends, such as how people use the product. Netpulse also uses cookies in its advertising services to help advertisers and publishers serve and manage ads across the Netpulse Network. <\/li> <li> <b>Log information<\/b> &ndash; When you access Netpulse Services, information generated during your session will be automatically recorded and stored on the Company&rsquo;s servers. These server logs may include information such as the webpages you visit, the content you access, the length and intensity of a workout tand the date and time of your request. <\/li> <li> <strong>Location data<\/strong> &ndash; The Company offers location-enabled services. If you use those services, Netpule may receive information about your actual location (such as the facility where you are working out and accessing the Netpulse Services). <\/li> <li> <strong>Links<\/strong> &ndash; We may present links in a format that enables us to keep track of whether these links have been followed. We use this information to improve the quality of our technology, customized content and advertising. <\/li> <li> <strong>Other sites<\/strong> &ndash; This Privacy Policy applies to Netpulse Services only. We do not exercise control over the sites displayed or linked to through the Netpulse Network or Netpulse Services. These other sites may place collect data or solicit personal information from you. <\/li><\/ul> <p>The Company only processes personal information for the purposes described in this Privacy Policy and/or the supplementary privacy notices for specific Netpulse Services. In addition to the above, such purposes include:<\/p> <h3>The display of customized content and advertising;<\/h3> <ul><li>Auditing, research and analysis in order to maintain, protect and improve the Netpulse Services and the use of exercise equipment;<\/li> <li>Ensuring the technical functioning of the Netpulse Network;<\/li> <li>Protecting the rights and property of Netpulse or our users; and<\/li> <li>Developing new services.<\/li><\/ul> <br /> <p>You acknowledge that in using the Netpulse Services you will be causing your personal information to be processed through Netpulse&rsquo;s computer networks, portions of which are located in California and other locations in the United States and portions of which may be located abroad. As a result, we process personal information on a server outside your own state/country. We may process personal information to provide the Netpulse Services, and also on behalf of and according to the instructions of a third party, such as our advertising partners and third-party content providers.<\/p> <h3>Choices for personal information<\/h3> <p>When you sign up for a particular service that requires registration, we ask you to provide personal information. You can decline to submit personal information to any of the Netpulse Services, in which case Netpulse may not be able to provide those services to you. As appropriate, we will offer you a way to opt out of the use of personal information for purposes. We will not collect or use sensitive information for purposes other than those described in this Privacy Policy and/or in the supplementary service privacy notices, unless we have obtained your prior consent. &ldquo;Sensitive personal information&rdquo; includes information we know to be related to confidential medical information, racial or ethnic origins, marital status and tied to personal information.<\/p> <h3>Information sharing<\/h3> <p>Netpulse may share your personal information with other companies or individuals outside of Netpulse in the following circumstances:<\/p> <ul><li> We have your consent.<\/li> <li> We provide such information to our subsidiaries, affiliated companies or other trusted businesses or persons for the purpose of processing personal information on our behalf. These parties are subject to appropriate confidentiality and security measures.<\/li> <li> We have a good faith belief that access, use, preservation or disclosure of such information is reasonably necessary to (a) satisfy any applicable law, regulation, legal process or enforceable governmental request, (b) enforce the Terms of Service, including investigation of potential violations thereof, (c) detect, prevent, or otherwise address fraud, security or technical issues, or (d) protect against harm to the rights, property or safety of Netpulse, its users or the public as required or permitted by law.<\/li><\/ul> <p>In addition, we use companies (Google and Yahoo!) and potentially others) to serve the advertisements on some of our pages. These companies and advertisers may place and access their cookies on your computer. Other companies&rsquo; use of their cookies is subject to their own privacy policies, not ours. We may use your information or allow advertisers or companies that serve advertisements access to your information to determine which advertisements you will see. This information may include your demographic information, geographic location, what content you access on our site, how you rate various content, language contained in your comments and other information.<\/p> <p>If Netpulse becomes involved in a merger, acquisition, or any form of sale of some or all of its assets, your personal information may be transferred in connection with such transaction, in which case we will use commercially reasonable efforts to ensure the confidentiality of any personal information involved in such transactions and provide notice when your personal information becomes subject to a different privacy policy.<\/p> <p>We may share with third parties certain pieces of aggregated, non-personal information, such as the number of users who viewed particular content, or the duration and intensity of a workout, for example. Such information does not identify you individually.<\/p> <p>Please contact us as provided below for any additional questions about the management or use of personal data.<\/p> <h3>Information security<\/h3> <p>We take appropriate security measures to protect against unauthorized access to or unauthorized alteration, disclosure or destruction of data. These include internal reviews of our data collection, storage and processing practices and security measures, as well as physical security measures to guard against unauthorized access to systems where we store personal data.<\/p> <p>We restrict access to personal information to Netpulse employees, contractors, agents and third parties who need to know that information in order to operate, develop or improve our services. These individuals are bound by appropriate confidentiality obligations.<\/p> <h3>Accessing and updating personal information<\/h3> <p>When you use the Netpulse Services, we make good faith efforts to provide you with access to your personal information and either to correct this data if it is inaccurate or to delete such data at your request if it is not otherwise required to be retained by law or for legitimate business purposes. We ask individual users to identify themselves and the information requested to be accessed, corrected or removed before processing such requests, and we may decline to process requests that are unreasonably repetitive or systematic, require disproportionate technical effort, jeopardize the privacy of others, or would be extremely impractical (for instance, requests concerning information residing on backup tapes), or for which access is not otherwise required.<\/p> <h3>Changes to this Privacy Policy: Please note that this Privacy Policy may change from time to time, and you should review it periodically.<\/h3> <h3>Questions: Please feel free to direct any questions or concerns regarding this Privacy Policy or Netpulse&rsquo;s treatment of personal information by contacting us through the Site or by writing to us at:<\/h3> <p> Privacy Matters<br>c/o Netpulse<br>2331 3rd Street<br>San Francisco, California, 94107 <\/p>"; 
 
IDS_LANGUAGE["privacypolicy"] = "Privacy Policy"; 
IDS_LANGUAGE["TGTerms&Conditions"]  = "<h1>Netpulse 이용 약관</h1>"; 
IDS_LANGUAGE["NPTermsAndConditions"]  = "<h1>Netpulse Terms & Conditions</h1>"; 
 
IDS_LANGUAGE["installer"] = new Array(); 
IDS_LANGUAGE.installer["notInstalledFeature"] = "This machine must be installed in order to use this feature. Please contact your sports club for more information."; 
 
// Login page 
IDS_LANGUAGE["login"] = new Array(); 
IDS_LANGUAGE.login["userId"] = '<span>%s</span>'; 
IDS_LANGUAGE.login["enterYourUserIdLogin"] = "다음 이름으로 로그인 %s"; 
IDS_LANGUAGE.login["passwordDialog"] = "<h1>암호 이미지를 선택하십시오.</h1>"; 
IDS_LANGUAGE.login["UninstaledMachine"] = "This machine is in an uninstalled state."; 
IDS_LANGUAGE.login["EnterUserIdUpTo10"] = "xID를 최대 10자리까지 입력해 주십시오."; 
IDS_LANGUAGE.login["EnterUserIdUpTo14"] = "xID를 최대 14자리까지 입력해 주십시오."; 
IDS_LANGUAGE.login["InvalidUserTry"] = "Invalid User. Try again."; 
IDS_LANGUAGE.login["UnregisteredUserId"] = "The User ID you entered is not registered."; 
IDS_LANGUAGE.login["NoPasswordSelected"] = "선택한 암호가 없습니다."; 
IDS_LANGUAGE.login["3IncorrectPasswordsEntered"] = "You have entered three incorrect passwords. Exiting."; 
IDS_LANGUAGE.login["PleaseTryAgainError"] = "오류가 발생했습니다. 다시 로그인을 시도하십시오."; 
IDS_LANGUAGE.login["IncorrectPassword"] = "암호가 올바르지 않습니다."; 
IDS_LANGUAGE.login["NetworkCommunicationError"] = "네트워크와 통신하는 중 문제가 발생했습니다. 나중에 다시 시도하십시오."; 
IDS_LANGUAGE.login["InvalidServerRequest"] = "Invalid Server Request."; 
IDS_LANGUAGE.login["SelectImage"] = "Selected Image"; 
IDS_LANGUAGE.login["enter"] = "enter"; 
IDS_LANGUAGE.login["deny"] = "거부"; 
IDS_LANGUAGE.login["accept"] = "동의"; 
IDS_LANGUAGE.login["selection"] = "<center>Your <br> Selection<br></center>"; 
IDS_LANGUAGE.login["ThereWasLoginProblem"] = "입력하신 xID 또는 패스코드가 정확하지 않습니다.";
IDS_LANGUAGE.login["IncorrectValidationOfUser"] = "The User was not Validated Correctly."; 
IDS_LANGUAGE.login["welcome"] = "님 환영합니다"; 
IDS_LANGUAGE.login["sucessfullLogin"] = "<br/>  성공적으로 로그인하셨습니다!"; 
IDS_LANGUAGE.login["register"]="등록하기"; 
IDS_LANGUAGE.login["createAnAccount"]="계정 만들기"; 
 
IDS_LANGUAGE.login["IsRegistered"] = "<h1>이미 등록하셨나요? 로그인하세요.</h1>"; 
IDS_LANGUAGE.login["Yet Unregistered"] = "<h1>아직 등록하지 않으셨나요?</h1>"; 
IDS_LANGUAGE.login["NotaValidUser"] ="User ID is not valid. Please try again."; 
IDS_LANGUAGE.login["newUser"] ="<h1>New User?</h1>"; 
IDS_LANGUAGE.login["createNewAccount"] ="Create an account in less than 30 seconds"; 
IDS_LANGUAGE.login["viewPrivacyPolicy"] = "View our privacy policy"; 

IDS_LANGUAGE.login["passcodeLogin"] = "패스코드를 입력하십시오.";
IDS_LANGUAGE.login["incorrectPasscode"] = "패스코드가 올바르지 않습니다.";
IDS_LANGUAGE.login["3IncorrectPasscodes"] = "패스코드 입력 오류 3회입니다. 다시 시도하려면 로그인하십시오.";
IDS_LANGUAGE.login["passcodeMigrationTitle"] = "계정 마이그레이션";
IDS_LANGUAGE.login["passcodeMigration"] = "<p><strong>1회성 요청입니다.</strong></p><p>로그인 과정을 단순화하기 위해, 당사는 현재 그림 암호가 아닌 숫자 패스코드로 전환하고 있습니다.</p><p>키패드를 사용하여 향후 로그인을 위한 숫자 패스코드를 만드십시오.</p>";
 
//Registration Page 
IDS_LANGUAGE.register = { 
                "enter" : "enter", 
                "registrationProblemError" : "There was a problem with registration: <br/>Error ", 
                "regproblem" : "There was a problem with registration: <br/>", 
                "midunkownTryagain" : "MID is UNKNOWN, try again.", 
                "userIdtaken" : "입력하신 XID를 이미 가지고 있습니다. 다른 것을 입력하십시오.",
                "emailhastaken" : "입력한 이메일 주소가 채택됩니다. 다른 항목을 입력하십시오.", 
                "pleasenterValidemail" : "올바른 이메일 주소를 입력하십시오.", 
                "selectimagepassword" : "Please Select a Password Image", 
                "enterWeight" : "체중 입력", 
                "enterMinimumWeight" : "몸무게를 65보다 큰 값으로 입력하십시오.", 
                "enterMinimumWeightMetric" : "몸무게를 34보다 큰 값으로 입력하십시오.",
                "congratulation" : "님 축하합니다", 
                "youareLoggedin" : "Netpulse에 로그인하셨습니다!", 
 
 
                "enterGender" : "성별을 입력하십시오.<br/>", 
                "enterDOB" : "생일을 입력하십시오.<br/>", 
                "day" : "일",
        		"month" : "월",
        		"year" : "연도",
                "createUserid" : "<h2>계정 만들기</h2>", 
                "enterphoneNoforRegistration" : "<h4>전화 번호 또는 기억하기 쉬운 10-14자리 숫자를 입력하십시오.</h4>", 
                "registrationSteps2To6" : "<h2>이메일 주소 입력</h2>", 
                "e-mail" : "<span>E-mail</span>", 
                "regSteps3to6" : "<h2>이미지 암호를 선택하십시오.</h2>", 
 
                "selectPasswordImage" : "<h4>Select an Image you can remember. This will be your password for your user ID </h4>", 
                "animal" : "동물", 
                "Fruit" : "과일", 
                "Sports" : "스포츠", 
                "Other" : "기타", 
 
 		"passcodeString" : "패스코드",
		"regSteps3to6Passcode" : "네 자리 숫자의 패스코드를 선택하십시오.",
		"passcodeEmpty" : "계속하려면 네 자리 숫자의 패스코드를 선택하십시오.",
		"passcodeMustBe4Digits" : "패스코드는 네 자리 숫자여야 합니다.",
        "newPasscodeLabel" : "새 패스코드 입력",
        "confirmPasscodeLabel" : "패스코드 확인",
        "createPasscodeConfirm" : "패스코드를 확인해 주십시오.",
        "createPasscodeSuccess" : "패스코드가 확인되었습니다.",
        "createPasscodeFail" : "패스코드가 일치하지 않습니다. 다시 시도해 주십시오.",
        "createPasscodeReset" : "패스코드가 재설정되었습니다. 계속하려면 네 자리 숫자의 패스코드를 선택하십시오.",
 
               "regSteps4to6" : "<h2>성별 및 생년월일을 입력하십시오. </h2>", 
                "DOB" : "생년월일", 
                "regSteps5to6" : "<h2>체중 입력</h2>", 
                "weight" : "<span>체중</span>", 
                "regSteps6to6" : "<h2>정보를 검토하십시오</h2>", 
                "clickBacktocorrectEnteries" : "<h4>뒤로 화살표를 사용하여 입력한 항목을 수정할 수 있습니다.</h4>", 
                "congratulationMsg" : "<h2>Congratulations you're now logged into Netpulse</h2>", 
                "Email" : "Email", 
                "500Lbs" : "500 Lbs.", 
                "passwordImage" : "암호 이미지", 
                "regproblemString" : "There Was a Problem With Registration.", 
		"useridString" : "%s",
                "emailString1" : "이메일:", 
                "genderString1" : "성별:", 
                "DOBString1" : "생년월일:", 
                "weightString1" : "체중:", 
                "summaryTOS" : "I accept the Terms of Service", 
                "TOSLink" : "Click Here to Read the Terms of Service", 
                "acceptTermsAndConditions" : "이용 약관에 동의합니다.", 
                "mustAccept" : "You must accept the Terms of Service to continue.", 
                "mustAcceptTermsAndConditions" : "계속하려면 이용 약관에 동의해야 합니다.", 
                "anotherTime" : "Please try again at another time.", 
 
                //On Demand 
                "ondemandString" : "주문형 비디오",

                //xID Description
				"xidDescription" : "xID 사용자 ID 시스템은 숫자 ID 및 비밀번호를 이용하여 연결된 피트니스 장비, 모바일 앱 및 웹사이트용의 일반적인 로그인입니다. 작업 활동을 개인화하고 추적하기 위해 %s 를 볼 때 로그인하십시오."
}; 
 
//User Profile 
IDS_LANGUAGE.userProfile={ 
                'clubName':'홈 클럽:', 
                'userName':'사용자 이름:', 
                'last_workout_header':'마지막 운동', 
                'activity': '활동', 
                'completeWorkoutToBegin':'운동을 마치고 최신 통계 보기를 시작하세요!'                         
}; 
 
//Preferred Unit
IDS_LANGUAGE['preferredUnit'] = "선호 단위";
IDS_LANGUAGE['imperial'] = "야드-파운드";
IDS_LANGUAGE['metric'] = "미터";

//playlist 
IDS_LANGUAGE["addVideo"] = "재생 목록에 동영상을 추가해야 해당 동영상을 감상할 수 있습니다."; 
IDS_LANGUAGE["entertitle"] = "Enter a Title for Your New Playlist"; 
IDS_LANGUAGE["selectcategory"] ="<li><h2>아래에서 시작할 범주를 선택하십시오.</h2><button>모든 장르</button><button>모든 아티스트</button><button>새 비디오</button></li>"; 
IDS_LANGUAGE["selectToBegin"] ="아래 범주를 선택해 시작하십시오."; 
IDS_LANGUAGE["noVideo"] ="<li><p class='artist'>No Videos</p></li>"; 
IDS_LANGUAGE["customplaylistString"] = "맞춤형 재생 목록을 시작합니다!"; 
IDS_LANGUAGE["allGenres"] = "모든 장르"; 
IDS_LANGUAGE["allArtists"] = "모든 아티스트"; 
IDS_LANGUAGE["newVideos"] = "새 비디오"; 
IDS_LANGUAGE["ArtistString"] = "Artists"; 
IDS_LANGUAGE["latestVideoString"] = "최신 비디오"; 
IDS_LANGUAGE["VideoString"] = "Videos"; 
IDS_LANGUAGE["createPlaylistString"] = "<h1>뮤직 비디오 재생 목록 만들기</h1>"; 
IDS_LANGUAGE["PlaylistMsg"] ="<p>이제 운동 중 언제든지 나만의 뮤직 비디오 재생 목록을 만들 수 있습니다. 이 기능을 이용하려면 등록된 사용자여야 합니다. 아래 버튼을 클릭하여 로그인하거나 새 계정을 만드십시오.</p>" ;
IDS_LANGUAGE["login/regString"] = "로그인/지금 등록"; 
IDS_LANGUAGE["updatePlaylistString"] = "<h1>뮤직 비디오 재생 목록 업데이트</h1>"; 
IDS_LANGUAGE["view/editMsg"] ="<p>이이미 맞춤형 뮤직 비디오 재생 목록을 만드신 것 같습니다. 기존 재생 목록을 보거나 편집하시겠습니까? 아니면 처음부터 새로 재생 목록을 만드시겠습니까?</p>"; 
IDS_LANGUAGE["view/editList"] = "기존 목록 보기/편집"; 
IDS_LANGUAGE["createString"] = "새로 만들기"; 
IDS_LANGUAGE["erase'sExistingPlaylist"] = "(기존 재생 목록은 삭제됩니다.)"; 
IDS_LANGUAGE["createCustomPlaylist"] ="<h1>내 뮤직 비디오 재생 목록 만들기</h1>";
IDS_LANGUAGE["personalizePlaylistMsg"] ="<p>Personalize your workout with a custom music video playlist, accessible anytime you workout. You can choose from our selection of hundreds of videos to build a playlist of your own.</p>"; 
IDS_LANGUAGE["getStartString"] = "Get Started Now!"; 
IDS_LANGUAGE["addVideosString"] ="<h1>Add Videos Before Watching</h1>"; 
IDS_LANGUAGE["addVideoBeforeWatch"] = "<p>You must add videos to your playlist before you can watch it.</p>"; 
IDS_LANGUAGE["okayString"] ="Okay"; 
IDS_LANGUAGE["savingPlaylistString"]= "<h3>재생 목록 저장 중</h3>"; 
IDS_LANGUAGE["oneMoment"]="<p>One Moment...</p>"; 
IDS_LANGUAGE["saveChanges"]="Save Changes"; 
IDS_LANGUAGE["wouldliketosaveChanges"]="<p>Would you like to save the changes you've made to your playlist?</p>" ; 
IDS_LANGUAGE["don'tsaveChanges"]="Don't Save Changes"; 
IDS_LANGUAGE["logintoContinue"]="로그인하여 계속하기"; 
IDS_LANGUAGE["titleString"]="Title:"; 
IDS_LANGUAGE["editString"]="Edit"; 
IDS_LANGUAGE["shuffelString"]= "Shuffle"; 
IDS_LANGUAGE["watchNowButton"]= "지금 보기"; 
IDS_LANGUAGE["save&exitString"]= "Save & Exit"; 
IDS_LANGUAGE["saveString"]= "저장"; 
IDS_LANGUAGE["editPlaylist"] = "재생 목록 편집"; 
 
// iPod stuff 
IDS_LANGUAGE["song"] = "SONG"; 
IDS_LANGUAGE["time"] = "TIME"; 
IDS_LANGUAGE["artist"] = "ARTIST"; 
IDS_LANGUAGE["genres"] = "GENRES"; 
IDS_LANGUAGE["folder"] = "FOLDER"; 
IDS_LANGUAGE["albumn"] = "ALBUMS"; 
 
// Workout Page 
IDS_LANGUAGE["Laps Completed"] = "Laps Completed"; 
IDS_LANGUAGE["Elapsed Time"] = "Elapsed Time"; 
IDS_LANGUAGE["Distance"] = "거리"; 
IDS_LANGUAGE["lap equals"] = "1 lap = 1/4 mile"; 
 
//Watch View 
IDS_LANGUAGE['chanUnavailable'] = 'Unavailable'; 
 
// controlbar 
IDS_LANGUAGE["Time"] = "Time"; 
IDS_LANGUAGE["Pace"] = "Pace"; 
IDS_LANGUAGE["Avg Pace"] = "Avg Pace"; 
IDS_LANGUAGE["AvgeragePace"] = "Avgerage Pace"; 
IDS_LANGUAGE["AvgSpeed"] = "Avg Speed"; 
IDS_LANGUAGE["METS"] = "METS"; 
IDS_LANGUAGE["Cal/Hour"] = "Cal/Hour"; 
IDS_LANGUAGE["Avg HR"] = "Avg HR"; 
IDS_LANGUAGE["Cal/Minute"] = "Cal/Minute"; 
IDS_LANGUAGE["Watts"] = "Watts"; 
IDS_LANGUAGE["Menu"] = "Menu"; 
IDS_LANGUAGE["Pause"] = "Pause"; 
IDS_LANGUAGE["Resume"] = "Resume"; 
IDS_LANGUAGE["miles"] = "miles"; 
IDS_LANGUAGE["(mph)"] = "(mph)"; 
IDS_LANGUAGE["mph"] = "mph"; 
IDS_LANGUAGE["km"] = "km"; 
IDS_LANGUAGE["(km/h)"] = "(km/h)"; 
IDS_LANGUAGE["km/h"] = "km/h"; 
IDS_LANGUAGE["Floors"] = "Floors"; 
IDS_LANGUAGE["0.1 floors"] = "0.1 floors"; 
IDS_LANGUAGE["Steps"] = "Steps"; 
IDS_LANGUAGE["revolutions"] = "revolutions"; 
IDS_LANGUAGE["(strides/min)"] = "(strides/min)"; 
IDS_LANGUAGE["(% grade)"] = "(% grade)"; 
IDS_LANGUAGE["Speed"] = "Speed"; 
IDS_LANGUAGE["RPM"] = "RPM"; 
IDS_LANGUAGE["TotalStrides"] = "Total Strides"; 
IDS_LANGUAGE["Incline"] = "Incline"; 
IDS_LANGUAGE["Level"] = "Level"; 
IDS_LANGUAGE["Duration"] = "기간"; 
IDS_LANGUAGE["Data"] = "Data"; 
IDS_LANGUAGE["Track"] = "Track"; 
IDS_LANGUAGE["SimpleView"] = "Simple View"; 
IDS_LANGUAGE["Programs"] = "Programs"; 
IDS_LANGUAGE["WeightUnit"] = "Lbs."; 
 
// menu view 
IDS_LANGUAGE["WorkoutView"] = "Workout View"; 
IDS_LANGUAGE["iPod"] = "&nbsp;iPod<sup>&reg;</sup>"; 
IDS_LANGUAGE["Music"] = "Music"; 
IDS_LANGUAGE["OnDemandVideos"] = "주문형 비디오"; 
IDS_LANGUAGE["WatchTV"] = "Watch TV"; 
IDS_LANGUAGE["MyWorkouts"] = "My Workouts"; 
IDS_LANGUAGE["ExerciseTV"] = "Netpulse Labs"; 
IDS_LANGUAGE["PersonalNews"] = "Personal News"; 
IDS_LANGUAGE["EndWorkout"] = "End Workout"; 
 
// End of workout 
IDS_LANGUAGE["Workout Complete"] = "Workout Complete"; 
IDS_LANGUAGE["Workout Success"] = "You have successfully completed your workout."; //<-- First letter ("Y") capitalization varies 
IDS_LANGUAGE["WorkoutTime"] = "Workout Time"; 
IDS_LANGUAGE["Calories"] = "칼로리"; 
IDS_LANGUAGE["AveragePace"] = "Average Pace"; 
IDS_LANGUAGE["AverageHeartRate"] = "Average Heart Rate"; 
IDS_LANGUAGE["PeakHeartRate"] = "Peak Heart Rate"; 
IDS_LANGUAGE["AverageSpeed"] = "Average Speed"; 
IDS_LANGUAGE["Quit!"] = "Quit"; 
IDS_LANGUAGE["ThisSessionWillEndIn"] = "This session will end in"; 
IDS_LANGUAGE["seconds"] = "seconds"; 
IDS_LANGUAGE["endWorkingOut"] = "End Working Out"; 
IDS_LANGUAGE["newWorkout"] = "New Workout"; 
IDS_LANGUAGE["workoutSummary"] = "<h1>Workout Summary</h1>"; 
IDS_LANGUAGE["ToProperlyTrackThisWorkout"] = "To properly track this workout session please press 'Clear' or 'Stop' on the equipment control panel before ending your workout on the screen." 
IDS_LANGUAGE["User"] = "User"; 
 
// Select A Workout View 
IDS_LANGUAGE["Back"] = "Back"; 
IDS_LANGUAGE["Next"] = "Next"; 
IDS_LANGUAGE["Manual"] = "Manual"; 
IDS_LANGUAGE["Male"] = "남성"; 
IDS_LANGUAGE["Female"] = "여성"; 
IDS_LANGUAGE["GO!"] = "GO!"; 
IDS_LANGUAGE["Gender"] = "성별"; 
 
// Device Direct Input Page 
IDS_LANGUAGE["close"] = "Close"; 
IDS_LANGUAGE["Clear"] = "Clear"; 
IDS_LANGUAGE["Enter"] = "Enter"; 
IDS_LANGUAGE["Current"] = "Current"; 
IDS_LANGUAGE["SPEED"] = "SPEED"; 
IDS_LANGUAGE["INCLINE"] = "INCLINE"; 
IDS_LANGUAGE["TGSpeeds"] = "&quot;Touch and Go&quot; Speeds"; 
IDS_LANGUAGE["TGIncline"] = "&quot;Touch and Go&quot; Incline"; 
IDS_LANGUAGE["percent"] = "%"; 
IDS_LANGUAGE["space"] ="space"; // keyboard 
IDS_LANGUAGE["shift"] ="shift"; // keyboard 
 
// Music View 
IDS_LANGUAGE["TopTracks"] = "TOP TRACKS"; 
IDS_LANGUAGE["FeaturedSelections"] = "FEATURED SELECTION: "; 
IDS_LANGUAGE["videoUnavilable"] = "<h3 id='videoPlayer'>Video Unavailable</h3>"; 
IDS_LANGUAGE["more"] = "More"; 

// Configuration Page 
IDS_LANGUAGE["Configuration"] = "Configuration"; 
 
// Please Resume Page 
IDS_LANGUAGE["PleaseResume"] = "Please resume exercising..."; 
 
// Are You There Page 
IDS_LANGUAGE["AreYouThere"] = "Are you there"; 
IDS_LANGUAGE["Yes"] = "Yes"; 

//YouTube
IDS_LANGUAGE["youTubeUnavailable"] = "YouTube 콘텐츠를 현재 이용할 수 없습니다.";

 
//  New Menu Page 
IDS_LANGUAGE["tv"] = "TV"; 
IDS_LANGUAGE["onDemand"] = "On Demand"; 
IDS_LANGUAGE["music"] = "뮤직 비디오"; 
IDS_LANGUAGE["personalNews"] = "Personal News"; 
IDS_LANGUAGE["ipod"] = "iPod"; 
IDS_LANGUAGE["workoutHistory"] = "Workout History"; 
IDS_LANGUAGE["survey"] = "Netpulse Survey"; 
IDS_LANGUAGE["workout"] = "Workout View"; 
IDS_LANGUAGE["endOfWorkout"] = "End Workout"; 
IDS_LANGUAGE["customMusicVideoPlaylist"] = "내 재생 목록"; 
IDS_LANGUAGE["virtualActive"] = "Virtual Active"; 
 
// modal.error Page 
IDS_LANGUAGE["UnableToCommunicatWithSlave"] = "Unable to communicate with the device."; 
IDS_LANGUAGE["SafetyMagnetPulled"] = "Please replace the emergency stop safety magnet."; 
 
IDS_LANGUAGE["WorkoutStarting"] = "Workout Starting"; 
IDS_LANGUAGE["StartingWorkoutIn"] = "Starting workout in "; 
IDS_LANGUAGE["PressTheCancelToStopSpeedChange"] = "Press 'Cancel' to stop the speed change."; 
IDS_LANGUAGE["Cancel"] = "취소"; 
IDS_LANGUAGE["SpeedChangeIn"] = "Speed change in "; 
IDS_LANGUAGE["LossOfSignalError"] = "Loss of signal"; 
IDS_LANGUAGE["OverSpeedError"] = "Over speed detected"; 
IDS_LANGUAGE["GradePotOutOfRangeError"] = "Grade pot out of range"; 
IDS_LANGUAGE["ContactWoodwaySupport"] = "Please contact Woodway support at 800-966-3929 option 3 for Service/Support"; 
 
IDS_LANGUAGE["mainMenu"] = new Array(); 
IDS_LANGUAGE.mainMenu["tv"] = "TV"; 
IDS_LANGUAGE.mainMenu["onDemand"] = "주문형 비디오";
IDS_LANGUAGE.mainMenu["music"] = "Music Videos"; 
IDS_LANGUAGE.mainMenu["ipod"] = "iPod"; 
IDS_LANGUAGE.mainMenu["workoutHistory"] = "Workout History"; 
IDS_LANGUAGE.mainMenu["playlist"] = "Custom Playlist"; 
IDS_LANGUAGE.mainMenu["virtualActive"] = "Virtual Active"; 
IDS_LANGUAGE.mainMenu["mmString"] = "<h1>Main Menu</h1>"; 
 
IDS_LANGUAGE.featuredContent = { 
                'featuredOnDemand' : '주요 VOD(Video on Demand)', 
                'featuredPlaylist' : 'Featured Music Video', 
                'featuredMusic' : '주요 음악 채널', 
                'featuredMain' : 'Featured Content', 
                'featuredVA' : 'Featured VA Course' 
}; 
 
IDS_LANGUAGE["csafe_enum"] = new Array(); 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_MILE" ]  =  "mile"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TENTH_MILE" ]  = "0.1 mile"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_HUNDREDTH_MILE" ]  = "0.01 mile"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_THOUSANDTH_MILE" ]  = "0.001 mile"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_FEET" ]  =  "ft"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_INCH" ]  =  "inch"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_POUNDS" ]  = "lbs."; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TENTH_POUNDS" ]  = "0.1 lbs."; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TEN_FEET" ]  = "10 feet"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_MPH" ]   =  "mile/hour"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TENTH_MPH" ]  = "0.1 mile/hour"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_HUNDREDTH_MPH" ]  = "0.01 mile/hour"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_FPM" ]   =  "Feet per minute"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_KM" ]    =  "kilometers"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TENTH_KM" ]  = "0.1 km"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_HUNDREDTH_KM" ]  = "0.01 km"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_METER" ]  = "meter"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TENTH_METER" ]  = "0.1 meter"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_CENTIMETER" ]  = "Cm"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_KG" ]    =  "Kg"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TENTH_KG" ]  = "0.1 kg"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_KPH" ]   =  "Km/hour"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TENTH_KPH" ]  = "0.1Km/hour"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_HUNDREDTH_KPH" ]  = "0.01 Km/hour"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_MPM" ]   =  "Meter per minute"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_MINUTES_PER_MILE" ]  = "Minutes/Mile"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_MINUTES_PER_KM" ]  = "Minutes/km"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_SECONDS_PER_KM" ]  = "seconds/km"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_SECONDS_PER_MILE" ]  = "seconds/mile"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_FLOORS" ]  = "floors"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TENTH_FLOORS" ]  = "0.1 floors"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_STEPS" ]  = "steps"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_REVOLUTIONS" ]  = "revolutions"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_STRIDES" ]  = "strides"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_STROKES" ]  = "strokes"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_BEATS" ]  = "beats"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_CALORIES" ]  = "calories"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_KP" ]    =  "What is a Kp"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_PERCENT_GRADE" ]  = "% Grade"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_HUNDREDTH_PERCENT_GRADE" ]  = "0.01 % Grade"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TENTH_PERCENT_GRADE" ]  = "0.1% Grade"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_TENTH_FLOORS_PER_MINUTE" ]  = "0.1 floors/minute"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_FLOORS_PER_MINUTE" ]  = "floors/minute"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_STEPS_PER_MINUTE" ]  = "steps/minute"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_REVOLUTIONS_PER_MINUTE" ]  = "revs/minute"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_STRIDES_PER_MINUTE" ]  = "strides/minute"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_STROKES_PER_MINUTE" ]  = "strokes/minute"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_BEATS_PER_MINUTE" ]  = "beats/minute"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_CALORIES_PER_MINUTE" ]  = "calories/minute";
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_CALORIES_PER_HOUR" ]  = "calories/hour"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_WATTS" ]  = "watts"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_KPM"]  =  "kpm"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_INCH_POUND"]  = "inch-Lb"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_FOOT_POUND"]  ="Foot-Lb"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_NEWTON_METERS"]  = "Newton-Meters"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_AMPERES"]  = "Amperes"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_THOUSANDTH_AMPERES"]  = "0.001 Amperes"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_VOLTS" ] = "Volts"; 
IDS_LANGUAGE.csafe_enum["CSAFE_UNIT_THOUSANDTH_VOLTS"]  = "0.001 Volts"; 
 
IDS_LANGUAGE.watch = { 
        nowPlaying : "지금 재생 중", 
        upNext : "Up Next", 
        current : "Current", 
        next : "Next", 
        videoNotAvailable : 'This Content is Currently Unavailable.', 
        fullCopy : "전체 화면을 활성화하려면 비디오를 누릅니다.", 
        backToMenu : "메뉴로 돌아가기", 
        addToPlaylist : "Add Song", 
        removeFromPlaylist : "Remove Song" 
}; 
 
IDS_LANGUAGE.playlist = {
    updated : '재생 목록이 업데이트됨',
    removed : '재생 목록에서 제거됨',
    emptied : '재생 목록이 비어 있음'
};

IDS_LANGUAGE.install = { 
    "selectDefaultLanguage" : "기본 언어 선택", 
    "selectDefaultCountry" : "기본 국가 선택", 
        "selectChannelIcon" : "채널 아이콘 선택", 
        "headerTitle" : "NetPulse", 
        "welcome" : "환영합니다", 
        "calibrationButton" : "여기를 눌러 터치스크린 보정 유틸리티를 실행하십시오.", 
        "installProgram" : "설치 프로그램이 이 장치 구성 및 테스트 단계로 안내합니다.", 
        "pleaseWaitMsg" : "기다려 주십시오.", 
        "welcomeNew" : { 
                "header" : "이 장치 구성을 시작하겠습니다!", 
                "deviceFeat" : "준비되었으면 '다음' 버튼을 클릭하여 장치의 다음 기능을 계속 구성하십시오.", 
                "devDisplay" : "장치 설정", 
                "devNetSet" : "네트워크 설정", 
                "devTvSig" : "TV 신호", 
                "devIpod" : "iPod 케이블" 
        }, 
        "welcomeExisting" : { 
                "header" : "이 장치를 다시 구성하시겠습니까?", 
                "preConfig" : "이 장치는 이전에 Netpulse 네트워크에서 구성되었던 것 같습니다.  아래 목록은 이 장치에 대해 저장되어 있는 구성 정보입니다." 
        }, 
        "touch" :{ 
                "header" : "Touch Screen Calibration", 
                "toCalibrate" : "To calibrate the touch screen, press the large button below" 
        }, 
        "networkInterface" : { 
                "header" : "네트워크 장치 선택", 
                "whichDevice" : "어떤 네트워크 장치를 사용해야 합니까?", 
                "refreshButton" : "네트워크 장치 목록 새로 고침", 
                "deviceList" : "다음 장치를 사용할 수 있습니다." 
        }, 
        "wirelessSetup" : { 
                "header" : "무선 설정", 
                "wirelessDetails" : "무선 네트워크의 세부 정보", 
                "essid" : "ESSID:", 
                "secret" : "키/암호:", 
                "networkType" : "네트워크 유형:", 
                "labelNone" : "없음", 
                "labelWep" : "WEP", 
                "labelPersonal" : "WPA Personal", 
                "labelPersonalTwo" : "WPA2 Personal" 
        }, 
        "testConnection" : { 
                "header" : "연결 테스트", 
                "subHeader" : "신호 세기", 
                "strength_25" : "25% -", 
                "strength_50" : "50% -", 
                "strength_75" : "75% -", 
                "strength_100" : "100% -" 
        }, 
        "connectionStatus" : { 
                "header" : "연결 상태:" 
        }, 
        "ipodPairing" : { 
                "header" : "iPod Cable Pairing", 
                "subHeader" : "Pair the iPod cable to this device", 
                "pairZeCabel" : "The installation program will now pair the iPod cable that is attached to this device.", 
                "deviceCommunicate" : "This will allow this device to communicate to an iPod using the attached iPod cable.", 
                "cableButtonCopy" : "When ready, press the 'Pair Cable' button below.", 
                "cableButton" : "Pair Cable", 
                "status" : "Status:", 
                "pairingComplete" : "100% Pairing Complete.", 
                "connected" : "Connected!", 
                "failedConnection" : "Connection Failed.", 
                "unableToConnect" : "Unable to connect to the wireless network. Please check the wireless connection settings and try again.", 
                "pairStart" : "Pairing Started...", 
                "pairTitle" : "Pairing iPod Cable", 
                "waitForIt" : "Please wait while the iPod cable is paired.", 
                "keepWaiting" : "This can take a few minutes." 
        }, 
        "systemPairing" : { 
                "header" : "시스템 페어링", 
                "subHeader" : "이 장치를 Netpulse 인증 서버에 페어링", 
                "press_install" : "네트워크 테스트'를 눌러 연결을 확인한 다음 '설치'를 눌러 Netpulse 네트워크에 이 장치를 설치합니다.", 
                "testNetworkButton" : "네트워크 테스트", 
                "checkForUpdates" : "업데이트 확인", 
                "installerButton" : "설치" 
        }, 
        "tvConfig" : { 
                "header" : "TV CONFIGURATION", 
                "subHeader" : "Choose Tuner Type", 
                "download" : "TV configuration files downloaded to this client.", //new 
                "upload" : "TV configuration files uploaded to server.", //new 
                "tunerType_existing" : "Use Existing Configuration", 
                "tunerType_download" : "Download Configuration", 
                "labelAnalog" : "Analog", 
                "tunerType_cable_standard" : "Standard Analog Cable", 
                "tunerType_cable_irc" : "Analog Cable IRC", 
                "tunerType_cable_hrc" : "Analog Cable HRC", 
                "labelDigital" : "Digital", 
                "tunerType_digital_cable" : "Digital Cable", 
                "tunerType_digital_ota" : "Digital Over the Air", 
                "tunerType_analog_digital_cable" : "OTA/Digital/Analog" 
        }, 
        'scanProgress' : { 
                "header" : "Scan In Progress...", 
                "toggleScanDetails" : "Show Scan Details", 
                "toggleScanDetailsOff" : "Hide Scan Details", 
                "cancelScanButton" : "Cancel Scan" 
        }, 
        "scanComplete" : { 
                "channelUp" : "Up", 
                "channelDown" : "Down", 
                "uploadConfiguration": "Save Configuration to Server", 
                "rescanChannels" : "Rescan Channels", 
                "addNewChannel" : "Add New Channel", 
                "advancedSetupDescription" : "Use advanced channel setup to rename and reposition channels.", 
                "showAdvancedChannelSetup" : "Advanced Channel Setup", 
                "channelInfoTitle" : "Channel", 
                "chanName" : "Channel Name:", 
                "editTitle" : "Edit Name", 
                "chanPos" : "Channel Position:", 
                "editPosition" : "Edit Position", 
                "chanIconLabel" : "Channel Icon:", 
                "editIcon" : "Edit Icon", 
                "hideAdvancedChannelSetup" : "Hide Advanced Setup" 
        }, 
        "noTv" : { 
                "header" : "No TV Tuner Found", 
                "subHeader" : "No Tv Tuner Device was detected.", 
                "callUs" : "If this is not correct please contact customer support before proceeding." 
        }, 
        "langConfig" : { 
                "header" : "Language Configuration", 
                "subHeader" : "Would you like to set the default language of this device?", 
                "openSelection" : "Click 'Select Default Language' to open the selection list.", 
                "languageButton" : "Select Default Language" 
        }, 
        "finished" : { 
                "header" : "마쳤습니다!", 
                "subHeader" : "축하합니다. 이 장치가 설치되었습니다!", 
                "completeInstall" : "이 사이트에서 모든 장치 설치를 완료했으면 다음 번호로 전화하십시오.", 
                "numberUS" : "1-877-NETPULSE #2(877-638-7857)(미국 또는 캐나다에서 전화를 거는 경우)", 
                "or" : "또는", 
                "numberOutside" : "01-415-643-0223(미국 또는 캐나다 외 지역에서 전화를 거는 경우)", 
                "supportTech" : "통화 중에 Netpulse 지원 기술(Netpulse Support Tech)에서 원격으로 각 장치를 테스트합니다." 
        }, 
        "navigation" :{ 
                "back_button" : "뒤로", 
                "next_button" : "다음", 
                "finish_button" : "마침" 
        }, 
        "keyboardContainer" : { 
                "cancelChanges" : "Cancel", 
                "saveTitle" : "Save" 
        },  
        "restart" : { 
                "oneMoment" : "One moment please....", 
                "pleaseWait" : "Please wait while the system is restarted.", 
                "ethernet" : "At least one network device is required. Ethernet is not set to eth0 or npwlan, resetting and then restarting", 
                "netStat" : "Network Status" 
        }, 
        "update" : { 
                "downloadUpdates" : "Please wait while we download updates and restart the software.", 
                "deviceSucceed" : "Device pairing succeeded", 
                "checkUpdate" : "Checking for software updates. Please wait.", 
                "checkUpdateTitle" : "Checking For Updates", 
                "noUpdateAvailable" : "Your software is up to date.", 
                "noUpdateAvailableTitle" : "No Update Available" 
        }, 
        "initialize" : { 
                "initialConfig" : "Initializing configuration...", 
                "initial" : "Initializing" 
        }, 
        "configuration" : { 
                "configApplied" : "Your configuration is being applied.  Do not turn off the computer.", 
                "saveConfig" : "Saving Configuation", 
                "change" : "[Configuration Changed]", 
                "wait" : "Please wait while the network is configured.", 
                "configNetwork" : "Configuring the Network", 
                "configWireless" : "The wireless network is not configured properly. If you would like to proceed using your wired connection, press 'yes'. To reconfigure your wireless settings, press 'no'.", 
                "configSuccess" : "Wireless network configured!", 
                "misconfigured" : "Your network is misconfigured.  This is probably fixable.  Please wait while the system is restarted." 
        }, 
        "computerName" : { 
                "noMachines" : "No available machines were found. Please contact Netpulse support.", 
                "selectPair" : "Please select/touch a machine below to pair it to this machine." 
        }, 
        "error" : { 
                "noStep" : " No such step :", 
                "fetchFail" : "Failed to fetch machine list: ", 
                "network" : "Failed to bring down network interface.", 
                "wireless" : "Unable to save wireless configuration." 
        }, 
        "settings" : { 
                "settingsWait" : "Please wait one moment while we retrieve settings...", 
                "settingsTitle" : "Retrieving Settings" 
        }, 
        "wireless" : { 
                "tvOnly" : "TV only. No network connection.", 
                "tvIpod" : " TV/iPod only. No network connection", 
                "interface" : "interface_type must be either 'wired', 'wireless' or 'none'." 
        },  
        "tvScan" : { 
                "scanning" : "Scanning TV Channels", 
                "iSaidWait" : "Please wait while the TV channels are scanned.", 
                "bePatient" : "This can take several minutes.", 
                "results" : "Channels found: ", 
                'configured' : 'TV Tuner Configured: ', 
                'unknown' : 'Unknown Tuner Type!', 
                "done" : "Done with scan", 
                'invalidTuner' : 'Invalid Tuner Type!', 
                "startingDigital" : "Starting digital TV scan..." 
        } 
         
}; 
IDS_LANGUAGE.installCore = { 
        'activeCount' : '단일 유선 네트워크 연결이 활성화되었을 때만 설치를 수행할 수 있습니다.', 
        'adapterType' : '시스템에서 Netpulse 게이트웨이로 유선 네트워크 연결을 사용할 경우에만 설치를 수행할 수 있습니다.', 
        'gatewayTest' : '게이트웨이 테스트:', 
        'result' : '결과:', 
        'serverTest' : '서버 테스트:', 
        'testsPassed' : '모든 네트워크 테스트 통과', 
        'oneFail' : '하나 이상의 네트워크 테스트 실패', 
        'serverInstall' : '서버 설치 메시지:', 
        'installSuccess' : '설치가 성공했습니다.', 
        'installFail' : '설치 실패', 
        'wired' : '유선 네트워크 인터페이스.', 
        'wireless' : '무선 네트워크 인터페이스.', 
        'bustedEthernet' : '이더넷 구성을 수정할 수 없습니다.  NetPulse 지원에 문의하십시오.', 
//        'done' : 'Done', 
//        'testApp' : 'Test Application', 
//        'close' : 'Close', 
        'ok' : '확인', 
        'server' : { 
                'success' : 'success', 
                'connectError': 'Connection Error', 
                'badXml' : 'Bad XML Response' 
        }, 
        'detect' : { 
                'auto' : '이 시스템이 자동 탐지되면 다음 속성이 나타납니다.', 
                'mfgName'        :         '제조업체 이름:         ', 
                'mfgId'         :         '제조업체 ID:                 ', 
                'model'         :         '모델:                                 ', 
                'serial'         :         '일련번호:                                ', 
                'fail'         : '시스템 제조업체 정보를 식별할 수 없습니다.'  
        }, 
        'load' : { 
                'prevInstalled' : '이 시스템은 이전에 Netpulse 네트워크에 설치되었습니다.', 
                'localConf' : '아래 목록은 로컬 구성 레코드의 내용입니다.', 
                'machineId' : 'Netpulse 시스템 ID:', 
                'macAddress' : 'MAC 주소:', 
                'noMatch' : '시스템 ID가 로컬 시스템 구성과 일치하지 않습니다.', 
                'yesMatch' : '시스템 ID가 로컬 시스템 구성과 일치합니다.', 
                'neverInstalled':'이 시스템은 Netpulse 네트워크에 설치된 적이 없습니다.' 
        }, 
        'testNetwork' : { 
                'title' : '네트워크 정보', 
                'gatewayIp' : '게이트웨이 IP:', 
                'interface' : '인터페이스:', 
                'adapter' : '어댑터 유형:', 
                'ipAddress': 'IP 주소:' 
        }, 
        'reference' :{ 
                'version' : '버전:', 
                'hostname' : '호스트 이름:', 
                'lanIP' : 'LAN IP:' 
        }, 
        'genError' :{ 
                'netConfigFail' : '네트워크 구성을 적용하지 못했습니다. [01]', 
                'netFail' : '네트워크 테스트 실패. [02]', 
                'invalid_machine_id' : '시스템 ID가 잘못되었습니다.', 
                'tooFew' : '인수가 너무 적습니다.', 
                'signalType' : '인식되지 않는 신호 유형:', 
                'alertTitle' : '경고', 
                'error' : '오류 -', 
                'tooMany' : '인수가 너무 많습니다.' 
        } 
}; 
IDS_LANGUAGE.channelInstaller = { 
                "notify" : { 
                        "titleLength" : "Channel title must be seven (7) characters or less", 
                        "titleInUse" : "Title in use on channel ", 
                        "outOfRange" : "Channel out of Range", 
                        "addingError" : "Error adding channel - ", 
                        "noChannelsYo" : "No channels found! - ", 
                        "channelNumber" : "Enter a channel number", 
                        "channelExists" : "Channel number already exists", 
                        "yourTunerSucks" : "All available Analog channels for your location have been enabled. Please go to Advanced Channel Setup and disable channels you do not want in the Lineup." 
                } 
}; 
 
// Demo mode 
IDS_LANGUAGE["demoHomeClub"] = "IHRSA 2013"; 
IDS_LANGUAGE["demoUser"] = "Netpulse User"; 
 
IDS_LANGUAGE.secretCode = { 
                "demo" : { 
                        "demoTitle" : "데모 모드", 
                        "demoModeOn" : "켜기", 
                        "demoModeOff" : "끄기" 
                }, 
                "shutDown" : { 
                        "shutTitle" : "종료'를 눌러 이 시스템을 끕니다.", 
                        "PowerDownButton" : "종료", 
                        "closeButton" : "닫기" 
                }, 
                "popErrorInstall" : "There was an error while writing the install file.", 
                "iframe" : { 
                        "refreshIframe" : "Refresh", 
                        "closeIframe" : "Close" 
                }, 
                "stickInstall" : { 
                        "start" : "Start", 
                        "close" : "Close", 
                        "usbStickInstaller" : "USB Stick Installer", 
                        "pressStartToBegin" : "Press 'start' to begin" 
                } 
}; 
 
IDS_LANGUAGE.gigya = { 
        'errors' : { 
                // non-gigya errors 
                'generic' : "An error occurred retrieving data. Please try again later", 
                'alreadyRegistered' : "This %1s account is associated with another UserID (%2s).  Please sign in with the other UserID, or choose a different account.", 
                'emailTaken' : "The Email address associated with this %1s account is already associated with another UserID. Please sign in with the other UserID, or choose a different account.", 
                'noEmail' : "Unable to retrieve email address from %1s", 
                 
                // Gigya documented errors 
                0 : " ", 
                100001 : "Data pending", 
                200001 : "Operation canceled", 
                200003 : "Permission not granted", 
                400001 : "Invalid request format", 
                400002 : "Missing required parameter", 
                400004 : "Invalid parameter format", 
                400006 : "Invalid parameter value", 
                400008 : "Invalid authentication header", 
                400011 : "Invalid redirect URI", 
                400012 : "Invalid response type", 
                400013 : "Unsupported grant type", 
                400014 : "Invalid grant", 
                400015 : "Code expired", 
                400050 : "Invalid userObject Format", 
                400060 : "Missing required provider parameter", 
                400070 : "Missing required recipients parameter", 
                400080 : "Missing required body parameter", 
                400090 : "Missing required subject parameter", 
                400092 : "Missing required ApiKey parameter", 
                400093 : "Invalid ApiKey parameter", 
                400094 : "Missing required uid parameter", 
                400095 : "Invalid uid parameter", 
                400096 : "Not supported", 
                400097 : "Missing required timestamp parameter", 
                400098 : "Invalid timestamp parameter", 
                400099 : "Invalid provider", 
                400100 : "No providers", 
                400101 : "Popup blocked", 
                400102 : "Invalid event handler", 
                400103 : "Invalid containerID", 
                400106 : "Not connected", 
                400120 : "Invalid site domain", 
                400122 : "%1s configuration error", // "Provider configuration error", 
                400124 : "DailyCap/FreqCap exceeded", 
                403001 : "Invalid session token", 
                403002 : "Request has expired", 
                403003 : "Invalid request signature", 
                403004 : "Duplicate nonce", 
                403005 : "Unauthorized user", 
                403006 : "Secret Sent Over Http", 
                403007 : "Permission denied", 
                403008 : "Invalid OpenID Url", 
                403009 : "%1s session expired", // "Provider session expired", 
                403010 : "Invalid Secret", 
                403011 : "Session has expired", 
                403012 : "No valid session", 
                403015 : "Missing request referrer", 
                403017 : "Unexpected %1s user", // "Unexpected provider user", 
                403022 : "Permission not requested", 
                403023 : "No user permission", 
                403024 : "%1s limit reached", // "Provider limit reached", 
                403025 : "Invalid token", 
                403030 : "Session expired retry", 
                404001 : "Friend not found", 
                404002 : "Category not found", 
                405001 : "Invalid API method", 
                409001 : "Identity exists", 
                413001 : "Request entity too large", 
                413002 : "Comment text too large", 
                500001 : "General Server Error", 
                500002 : "Server login error", 
                500014 : "Session migration error", 
                500020 : "Invalid site ID", 
                500023 : "%1s error", // "Provider error", 
                500024 : "No valid session", 
                500026 : "Network error", 
                500028 : "Database error", 
                500030 : "Invalid site domain", 
                500031 : "No %1s application", // "No provider application", 
                500032 : "Load failed", 
                501001 : "Invalid API method", 
                504001 : "Timeout" 
        } 
}; 
 
//Account Linking Page 
IDS_LANGUAGE.accounts =  {"accountsContentHeader" :"<h2>계정을 다른 서비스에 연결하여 정보 공유를 시작하십시오.</h2>"}; 
 
//TV Channels 
IDS_LANGUAGE.tv = { 
        'myChannels' : 'TV', 
        'login' : '로그인하거나 계정을 만들어 즐겨찾는 채널 저장을 시작하세요!', 
        'emptyFavorites' : '&quot;하트&quot; 즐겨찾기 목록에 추가할 채널.', 
        'channelGuide' : 'Netpulse 채널 가이드' 
}; 
 
//Workout History Page 
IDS_LANGUAGE.workout = { 
                'date' : '날짜', 
                'distance' : '거리', 
                'duration' : '기간', 
                'activity' : '활동', 
                'calories' : '칼로리', 
                'noworkouts' : 'You Currently Have No Workout History.' 
}; 
 
//general 
IDS_LANGUAGE["notAvailable"] = "Not Available"; 
IDS_LANGUAGE["noTrackMessage"] = "ATTENTION: THIS FITNESS MACHINE DOES NOT SUPPORT WORKOUT TRACKING. YOUR CURRENT WORKOUT WILL NOT BE DISPLAYED IN YOUR WORKOUT HISTORY. To capture your workout, please visit ";

//Matrix7xi Terms & Conditions/Privacy Policy
IDS_LANGUAGE["matrix7xiTermsPolicyContent"]= "<p><strong>Johnson Health Tech. Co., Ltd. Terms of Service<br/>Version 1.0 [4/8/13]</strong></p><ol><li><strong>Terms of Service</strong><p>These Terms of Service govern your access to and use of Johnson Health Tech. Co., Ltd. (&quot;JHT,&quot; including its subsidiaries, affiliates, partners, predecessors, successors, assignors and assignees) services, including (a) the JHT network, (b) fitness equipment that provides access to JHT software or content; and (c) any websites or web pages that provide access to the JHT Network (collectively, &quot;JHT Services&quot;). By accessing or using the JHT Services, you accept and agree to comply with these Terms of Service.</p></li><li><strong>Privacy Policy</strong><p>Any information you provide to JHT in connection with the JHT Services is subject to JHT's Privacy Policy, located at www.matrixfitness.com/content/7xi-privacy-policy and incorporated by reference into these Terms of Service.</p></li><li><strong>Registration & Account Information</strong><p>You agree that the information you provide JHT is true and accurate, and that JHT may discontinue access to the JHT Services and/or suspend or terminate your account in the event any information you provide is not true or accurate. You further represent that you have the legal capacity to enter into a binding contract with JHT. </p></li><li><strong>Use of Account</strong><p>You are responsible for maintaining the confidentiality of the password and account information under which you register for the JHT Services. You are fully responsible for all activities that occur under your account, and agree to notify JHT immediately of any unauthorized use of your account or account information or other breach of security.</p></li><li><strong>Content</strong><p>All information, data, text, graphics, photos, music, videos or other materials of any kind accessed via the JHT Services (&quot;Content&quot;) is the sole responsibility of the Content's originator. You understand that by using the JHT Services, you may be exposed to Content that you find to be offensive or objectionable. You also understand that JHT is not responsible for the accuracy of any Content that you access via the JHT Services, or any loss or damage of any kind incurred as a result of your access to or use of any Content made available via the JHT Services</p></li><li><strong>Conduct</strong><p>By accessing the JHT Services, you agree that you will abide by all applicable laws and that you will accept and adhere to the Terms of Use/Service of any applications accessed via the JHT Services. You will not use the JHT Services to engage in conduct that is unlawful, abusive, defamatory, harassing, obscene, hateful or otherwise objectionable or that infringes any intellectual property rights of any party.</p></li><li><strong>Contributions to JHT</strong><p>You agree that any ideas, suggestions, documents and/or proposals (&quot;Contributions&quot;) submitted by you to JHT are not confidential or proprietary and that JHT shall be entitled to use such Contributions for any purpose without compensation to you or any third party. </p></li><li><strong>Indemnity</strong><p>You agree to indemnify and hold JHT (as defined in paragraph 1 above) and all of the present and former owners, directors, officers, agents, representatives, employees and insurers of JHT (as defined in paragraph 1 above) (collectively, &quot;JHT Parties&quot;) harmless from any claim or demand, including reasonable attorneys' fees, made by any third party in any way relating to or arising out of your use of the JHT Services.</p></li><li><strong>Modification or Termination of Services</strong><p>JHT reserves the right, in its discretion and without notice, to modify, discontinue or terminate the JHT Services and/or your access to the JHT Services for any reason, without having any liability to you for doing so. </p></li><li><strong>Advertisers, Applications and Links</strong><p>You agree that JHT does not endorse and is not responsible for the content of any advertising accessed in connection with the JHT Services, or any loss arising therefrom. You further acknowledge that JHT is not responsible for the content of any applications or websites linked via the JHT Services. </p></li><li><strong>JHT's Proprietary Rights</strong><p>You acknowledge that the JHT Services, any software used in connection with the JHT Services and any Content provided via the JHT Services contain proprietary and confidential information protected by applicable intellectual property and other laws. You agree that, except as authorized by JHT or allowed by applicable law and except as expressly permitted by these Terms of Service, you will not make any use of the JHT Services, software or Content. </p></li><li><strong>Health Disclaimer</strong><p>Any information provided to you in connection with the JHT Services does not constitute medical advice. You should seek the advice of a qualified physician before beginning any health, fitness or wellness regimen. </p></li><li><strong>Disclaimer of Warranties</strong><p>YOU EXPRESSLY UNDERSTAND AND AGREE THAT YOUR USE OF THE JHT SERVICES IS AT YOUR SOLE RISK. THE JHT SERVICES ARE PROVIDED ON AN &quot;AS IS&quot; AND &quot;AS AVAILABLE BASIS,&quot; AND JHT EXPRESSLY DISCLAIMS ALL WARRANTIES OF ANY KIND, WHETHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT.</p><p>JHT MAKES NO WARRANTY AND DISCLAIMS ALL LIABILITY FOR (I) THE COMPLETENESS, ACCURACY, AVAILABILITY, TIMELINESS, SECURITY OR RELIABILITY OF THE JHT SERVICES OR ANY CONTENT ACCESSED VIA THE JHT SERVICES; (II) ANY HARM TO YOUR COMPUTER SYSTEM OR OTHER DEVICE, LOSS OF DATA OR OTHER HARM THAT RESULTS FROM YOUR ACCESS TO OR USE OF THE JHT SERVICES; AND (III) THE DELETION OF, OR THE FAILURE TO STORE OR TO TRANSMIT, ANY CONTENT RELATED TO THE JHT SERVICES. NO ADVICE OR INFORMATION, WHETHER ORAL OR WRITTEN, OBTAINED FROM THE JHT PARTIES OR THROUGH THE JHT SERVICES WILL CREATE ANY WARRANTY NOT EXPRESSLY STATED IN THESE TERMS OF SERVICE. </p></li><li><strong>Limitations of Liability</strong><p>TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE JHT PARTIES SHALL NOT BE LIABLE FOR ANY INDIRECT, INCIDENTAL, SPECIAL, CONSEQUENTIAL OR PUNITIVE DAMAGES, OR ANY LOSS OF PROFITS OR REVENUES, WHETHER INCURRED DIRECTLY, OR ANY LOSS OF DATA, USE, GOOD-WILL, OR OTHER INTANGIBLE LOSSES, RESULTING FROM: (I) YOUR ACCESS TO OR USE OF OR INABILITY TO ACCESS OR USE THE JHT SERVICES, (II) ANY CONDUCT OR CONTENT OF ANY THIRD PARTY ACCESSED VIA THE JHT SERVICES, INCLUDING WITHOUT LIMITATION ANY DEFAMATORY, OFFENSIVE OR ILLEGAL CONDUCT OF OTHER USERS OR THIRD PARTIES; (III) ANY CONTENT OBTAINED FROM THE JHT SERVICES; OR (IV) UNAUTHORIZED ACCESS, USE OR ALTERATION OF YOUR REGISTRATION AND ACCOUNT INFORMATION, TRANSMISSIONS OR CONTENT.</p></li><li><strong>Severability</strong><p>If any provision of these Terms of Service is deemed not enforceable under applicable law, it is intended that the remaining provisions be deemed severable and enforced to the fullest extent allowed by law. </p></li><li><strong>Notice</strong><p>JHT may provide you with notices, including notices regarding changes to these Terms of Service, by mail, email, text message, postings accessible via the JHT Services or other reasonable means. Any notices you provide to JHT pursuant to these Terms of Service should be sent to:</p> <p>Director of Console Technology<br/>1600 Landmark Drive<br/>Cottage Grove, WI 53527</p><p>Email inquiries may be sent to JHTconsoleservices@johnsonfit.com. </p></li><li><strong>Headings</strong><p>The section headings in these Terms of Service are for convenience only and have no legal effect.</p></li><li><strong>Costs of Enforcement</strong><p>In the event that you do not comply with these Terms of Service, JHT shall be entitled to recover from you all costs incurred by JHT in enforcing these Terms of Service, including attorneys' fees.</p></li><li><strong>Assignment and Successors</strong><p>JHT shall have the right to assign its rights and delegate its duties under these Terms of Service. These Terms of Service shall inure to the benefit of, and shall be enforceable by, JHT. You do not have the right to assign your rights or delegate your obligations under these Terms of Service.</p></li><li><strong>Choice of Law and Forum</strong><p>The provisions in this paragraph shall apply to any use of the JHT Services in the United States. As to any such use, these Terms of Service shall be governed by, and construed in accordance with, the laws of the State of Wisconsin, without application of principles of conflicts of laws. With respect to any dispute, controversy or claim arising out of or relating to your use of the JHT Services in the United States and these Terms of Service, you agree and consent to exclusive personal jurisdiction in the State of Wisconsin and agree that the Circuit Court of Dane County, Wisconsin shall be the exclusive and mandatory forum for the resolution of any such disputes, controversies or claims. You expressly waive the right to commence, prosecute, remove, seek to remove, transfer or seek to transfer any suit, action or proceeding in or to a federal court, a court in a state other than the State of Wisconsin or a court in the State of Wisconsin other than the Circuit Court of Dane County, Wisconsin.</p></li><li><strong>Waiver</strong><p>The waiver by JHT of any violation by you of these Terms of Service shall not operate, or be construed, as a waiver of any subsequent violation.</p></li> <li><strong>Causes Beyond JHT's Control</strong><p>JHT shall not be liable for its failure to provide the JHT Services or otherwise comply with these Terms of Service to the extent such failure results from causes beyond its reasonable control.</p></li> <li><strong>Survival</strong><p>The termination of these Terms of Service or your use of the JHT Services shall not relieve you from obligations which are intended or understood by their nature to survive termination.</p></li> <li><strong>Remedies Cumulative</strong><p>All of JHT's remedies referred to in these Terms of Service are separate and cumulative, and no one of them, whether or not exercised, shall be deemed to be exclusive of any of the other rights and shall not limit or prejudice any other rights and remedies as may be available to JHT under law or equity.</p></li> <li><strong>Entire Agreement</strong><p>These Terms of Service constitute the entire agreement between JHT and you regarding your use of the JHT Services. These Terms of Service supersede all prior agreements or understandings between JHT and you concerning the JHT Services.</p></li> <li><strong>Violations</strong><p>Please report any violations of these Terms of Service to JHT at JHTconsoleservices@johnsonfit.com.</p></li> </ol><ol><li><p><b>Acceptance of Terms</b></p></li></ol><p>Netpulse, Inc. (&ldquo;Netpulse&rdquo; or the &ldquo;Company&rdquo;, which terms shall include affiliates of Netpulse, Inc.) provides the Netpulse Services (as defined below) to you subject to the following Terms of Service (&ldquo;TOS&rdquo;), which may be updated by the Company from time to time without notice to you.  Netpulse Services includes any services associated with the Company for use by you, including, without limitation, (a) the netpulse.com website, and any related domains or subdomains (collectively, the &ldquo;Site&rdquo;); (b) access and use of the network (the &ldquo;Netpulse Network&rdquo;) of content and exercise-related information through any device, equipment, display or other means of access to the Netpulse Services, whether now in existence or in the future; and (c) use of exercise equipment that contains Netpulse-enabled content or controls, to the extent that such use relates to hardware, software or services provided by Netpulse.</p><p>By accessing and using the Netpulse Services, you accept and agree to be bound by the terms and provision of these TOS.  If you do not agree to these TOS, you should stop use of the Netpulse Services. These TOS include the Netpulse Privacy Policy located at www.netpulse.com.  In addition, any rules, guidelines or additional terms that may be presented to you in the course of your use of the Netpulse Services are incorporated by reference into these TOS.</p><ol start=2>    <li><p><b>Registration and Account Information</b></p></li></ol><p>You represent that you are a natural person with the legal capacity to form a binding contract and be subject to these TOS under the laws of any applicable jurisdiction. You also agree that you will provide true, accurate, current and complete information about yourself as prompted by the Netpulse Service&rsquo;s registration form, with updates, as applicable. If you provide any information that is untrue, inaccurate, not current or incomplete, or Netpulse has reasonable grounds to suspect that such information is untrue, inaccurate, not current or incomplete, Netpulse has the right to suspend or terminate your account and refuse to provide you any further access to any portion of the Netpulse Services.   You understand that through your use of the Netpulse Services, you consent to the collection and use, as set forth in the Netpulse privacy policy, of this information, including the transfer of this information outside your applicable jurisdiction to other countries for storage, processing and use by Netpulse and its affiliates.</p><p>You are responsible for maintaining the confidentiality of the password and account name or ID your register under, and are fully responsible for all activities that occur under your account. The Company is not liable for any failure on your part to comply with the foregoing.  You agree to immediately notify Netpulse of any unauthorized use of your password or account or any other breach of security.</p><ol start=3>    <li><p><b>Health Disclaimer</b></p></li></ol><p>The Netpulse Services and the Site may provide physiological data about your body along with information applications and content published over the Internet and are intended only to assist you and other users with respect to such user&rsquo;s personal health, fitness and wellness efforts. Netpulse is not a medical organization and the Company does not and cannot give you medical advice or diagnoses. Nothing transmitted or contained in the Netpulse Services, the Site or through the Netpulse Network should be construed as medical advice or a diagnosis. Any data or reports generated by through use of the Netpulse Services should not be interpreted as a substitute for physician consultation, evaluation, or treatment. The Company urges you to seek the advice of a qualified physician before beginning any health, fitness &amp; wellness related effort or regimen.</p><ol start=4>    <li><p><b>Content and Conduct</b></p></li></ol><p>You understand that all information, data, text, software, music, sound, photographs, graphics, video, messages, tags, or other materials (&ldquo;Content&rdquo;), whether publicly posted or privately transmitted, are the sole responsibility of the person from whom such Content originated (except that anything disclaimed under Section 3 above is not the responsibility of Netpulse). You understand that by using the Netpulse Services, you may be exposed to Content that is offensive or objectionable. Under no circumstances will Netpulse be liable in any way for any Content, including, but not limited to, any errors or omissions in any Content, or any loss or damage of any kind incurred as a result of the use of any Content posted, emailed, transmitted or otherwise made available via the Netpulse Services.</p><p>You agree you shall not use the Netpulse Services to:</p><ol>    <ol>        <li><p>upload, post,        email, transmit or otherwise make available any Content that is        unlawful, harmful, threatening, abusive, harassing, tortious,        defamatory, vulgar, obscene, libelous, invasive of another&rsquo;s        privacy, hateful, or racially, ethnically or otherwise        objectionable; upload, post, email, transmit or otherwise make        available any Content that infringes any patent, trademark, trade        secret, copyright, privacy, publicity or other proprietary rights        of any party;</p></li>        <li><p>upload, post, email, transmit or        otherwise make available any Content that you do not have a right        to make available under any law or under contractual or fiduciary        relationships (such as inside information, proprietary and        confidential information learned or disclosed as part of employment        relationships or under nondisclosure agreements);</p></li>        <li><p>upload, post, email, transmit or        otherwise make available any unsolicited or unauthorized        advertising, promotional materials, &ldquo;junk mail,&rdquo;        &ldquo;spam,&rdquo; &ldquo;chain letters,&rdquo; &ldquo;pyramid        schemes,&rdquo; or any other form of solicitation.        </p></li>        <li><p>forge headers or otherwise        manipulate identifiers in order to disguise the origin of any        Content transmitted through the Netpulse Services or the Netpulse        Network;</p></li>        <li><p>upload, post, email, transmit or        otherwise make available any material that contains software        viruses, &ldquo;Trojan horses&rdquo; or any other computer code,        files or programs designed to interrupt, destroy or limit the        functionality of any computer software or hardware or        telecommunications equipment;</p></li>        <li><p>interfere with or disrupt the        Netpulse Services or servers or networks connected to the Netpulse        Services, or disobey any requirements, procedures, policies or        regulations of networks connected to the Netpulse Services,        including using any device, software or routine to bypass our robot        exclusion headers;</p></li>        <li><p>intentionally or unintentionally        violate any applicable local, state, national or international law,        including, but not limited to, regulations promulgated by the U.S.        Securities and Exchange Commission, any rules of any national or        other securities exchange, including, without limitation, the New        York Stock Exchange, the American Stock Exchange or the NASDAQ, and        any regulations having the force of law;</p></li>        <li><p>impersonate any person or entity,        or falsely state or otherwise misrepresent your affiliation with a        person or entity;</p></li>        <li><p>&ldquo;stalk&rdquo; or otherwise        harass anyone; and/or</p></li>        <li><p>collect or store personal data        about other users in connection with the prohibited conduct and        activities set forth in paragraphs a through m above.</p></li>    </ol></ol><p>You acknowledge, consent and agree that Netpulse may access, preserve and disclose your account information if required to do so by law or in a good faith belief that such access preservation or disclosure is reasonably necessary to: (i) comply with legal process; (ii) enforce these TOS (iii) respond to your requests for customer service; or (v) protect the rights, property or personal safety of Netpulse, its users or the public.</p><p>You understand that the Netpulse Services and software embodied within the Netpulse Services may include security components that permit digital materials to be protected, and that use of these materials is subject to usage rules set by Netpulse and/or content providers who provide content to the Netpulse Services. You may not attempt to override or circumvent any of the usage rules embedded into the Netpulse Services. Any unauthorized reproduction, publication, further distribution or public exhibition of the materials provided on the Netpulse Services, in whole or in part, is strictly prohibited.</p><ol start=5>    <li><p><b>Interstate    and International Nature of the Netpulse Services</b>    </p></li></ol><p>You acknowledge that in using the Netpulse Services you will be causing communications to be sent through Netpulse&rsquo;s computer networks, portions of which are located in California and other locations in the United States and portions of which may be located abroad. As a result, and also as a result of Netpulse&rsquo;s network architecture and business practices and the nature of electronic communications, even communications that seem to be intrastate in nature can result in the transmission of interstate communications regardless of where you are physically located at the time of transmission. Accordingly, you acknowledge that use of the Netpulse Services results in interstate data transmissions.</p><ol start=6>    <li><p><b>Contributions    to Netpulse</b></p></li></ol><p>By submitting ideas, suggestions, documents, and/or proposals (&ldquo;Contributions&rdquo;) to Netpulse through the Site, feedback mechanisms or otherwise, you acknowledge and agree that: (a) your Contributions do not contain confidential or proprietary information; (b) Netpulse is not under any obligation of confidentiality, express or implied, with respect to the Contributions; (c) Netpulse shall be entitled to use or disclose (or choose not to use or disclose) such Contributions for any purpose, in any way, in any media worldwide; (d) Netpulse may have something similar to the Contributions already under consideration or in development; (e) your Contributions automatically become the property of Netpulse without any obligation of Netpulse to you; and (f) you are not entitled to any compensation or reimbursement of any kind from Netpulse under any circumstances.</p><ol start=7>    <li><p><b>Indemnity</b></p></li></ol><p>You agree to indemnify and hold Netpulse and its subsidiaries, affiliates, officers, agents, employees, partners and licensors harmless from any claim or demand, including reasonable attorneys&rsquo; fees, made by any third party due to or arising out of your use of the Netpulse Services, your connection to the Netpulse Services, your violation of these TOS, or your violation of any rights of another.</p><ol start=8>    <li><p><b>Modification    or Termination of Netpulse Services</b></p></li></ol><p>Netpulse reserves the right at any time, in its sole discretion, without notice, to modify or discontinue, temporarily or permanently, any part of the Netpulse Services or to terminate, limit your access to or suspend your Netpulse account and access to the Netpulse Services for any reason. You agree that the Company shall not be liable to you or to any third party for any modification, suspension or discontinuance of any part of the Netpulse Services, or for any termination, limit to access or suspension of your Netpulse account.</p><ol start=9>    <li><p><b>Advertisers</b></p></li></ol><p>Your dealings with, or participation in promotions of, advertisers or other third parties found on or through the Netpulse  Services, including payment and delivery of related goods or services, and any other terms, conditions, warranties or representations associated with such dealings, are solely between you and such advertiser or third party. You agree that Netpulse shall not be responsible or liable for any loss or damage of any sort incurred as the result of any such dealings with advertisers or third parties, or as the result of the presence of such advertisers on the Netpulse Network or through the Netpulse Services.</p><ol start=10>    <li><p><b>Links to    Third Parties</b></p></li></ol><p>The Netpulse Services may provide, or third parties may provide, links to other websites or resources. You acknowledge and agree that Netpulse is not responsible for the availability of such external sites or resources, and does not endorse and is not responsible or liable for any Content, advertising, products or other materials on or available from such sites or resources. You further acknowledge and agree that Netpulse shall not be responsible or liable, directly or indirectly, for any damage or loss caused or alleged to be caused by or in connection with use of or reliance on any such Content, goods or services available on or through any such site or resource.</p><ol start=11>    <li><p><b>Netpulse&rsquo;s    Proprietary Rights</b></p></li></ol><p>You acknowledge and agree that the Netpulse Services, any necessary software used in connection with the Netpulse Services and Netpulse Network (&ldquo;Software&rdquo;) and Content provided through the Netpulse Services contain proprietary and confidential information that is protected by applicable intellectual property and other laws. You further acknowledge and agree that Content contained in advertisements or information presented to you through the Netpulse Services or by advertisers is protected by copyrights, trademarks, service marks, patents or other proprietary rights and laws. Except as expressly permitted by applicable law or as authorized by Netpulse or the applicable licensor (such as an advertiser), you agree not to modify, rent, lease, loan, sell, distribute, transmit, broadcast, publicly perform or create derivative works based on the Netpulse Services, such Content or the Software, in whole or in part.</p><p>Netpulse grants you a personal, non-transferable and non-exclusive right and license to use the object code of its Software on a single computer; provided that you do not (and do not allow any third party to) copy, modify, create a derivative work from, reverse engineer, reverse assemble or otherwise attempt to discover any source code, sell, assign, sublicense, grant a security interest in or otherwise transfer any right in the Software. You agree not to modify the Software in any manner or form, nor to use modified versions of the Software, including (without limitation) for the purpose of obtaining unauthorized access to the Netpulse Services.</p><p>You agree that all of Netpulse&rsquo;s trademarks, trade names, service marks and other Netpulse logos and brand features, and product and service names are trademarks and the property of Netpulse Inc. Without Netpulse&rsquo;s prior permission, you agree not to display or use in any manner the Netpulse Marks.</p><ol start=12>    <li><p><b>Disclaimer    of Warranties</b></p></li></ol><p>YOU EXPRESSLY UNDERSTAND AND AGREE THAT:</p><ol>    <ol>        <li><p>YOUR USE OF        THE NETPULSE SERVICES AND SOFTWARE ARE AT YOUR SOLE RISK. THE        NETPULSE SERVICES, THE NETPULSE NETWORK AND SOFTWARE ARE PROVIDED        ON AN &ldquo;AS IS&rdquo; AND &ldquo;AS AVAILABLE&rdquo; BASIS.        NETPULSE AND OFFICERS, EMPLOYEES, AGENTS, PARTNERS AND LICENSORS        EXPRESSLY DISCLAIM ALL WARRANTIES OF ANY KIND, WHETHER EXPRESS OR        IMPLIED, INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF        TITLE, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND        NON-INFRINGEMENT.</p></li>        <li><p>NETPULSE AND ITS OFFICERS,        EMPLOYEES, AGENTS, PARTNERS AND LICENSORS MAKE NO WARRANTY THAT (i)        THE NETPULSE SERVICES OR SOFTWARE WILL MEET YOUR REQUIREMENTS; (ii)        THE NETPULSE SERVICES, NETPULSE NETWORK OR SOFTWARE WILL BE        UNINTERRUPTED, TIMELY, SECURE OR ERROR-FREE; (iii) THE RESULTS THAT        MAY BE OBTAINED FROM THE USE OF THE NETPULSE SERVICES, THE NETPULSE        NETWORK OR SOFTWARE WILL BE ACCURATE OR RELIABLE; (iv) THE QUALITY        OF ANY PRODUCTS, SERVICES, INFORMATION OR OTHER MATERIAL PURCHASED        OR OBTAINED BY YOU THROUGH THE NETPULSE SERVICES OR THE NETPULSE        NETWORK WILL MEET YOUR EXPECTATIONS; AND (v) ANY ERRORS IN THE        SOFTWARE WILL BE CORRECTED.</p></li>        <li><p>ANY MATERIAL DOWNLOADED OR        OTHERWISE OBTAINED THROUGH THE USE OF THE NETPULSE SERVICES, THE        NETPULSE NETWORK OR SOFTWARE IS ACCESSED AT YOUR OWN DISCRETION AND        RISK, AND YOU WILL BE SOLELY RESPONSIBLE FOR AND HEREBY WAIVE ANY        AND ALL CLAIMS AND CAUSES OF ACTION WITH RESPECT TO ANY DAMAGE TO        YOUR COMPUTER SYSTEM, INTERNET ACCESS, DOWNLOAD OR DISPLAY DEVICE,        OR LOSS OF DATA THAT RESULTS FROM THE DOWNLOAD OF ANY SUCH        MATERIAL.</p></li>        <li><p>NO ADVICE OR INFORMATION, WHETHER        ORAL OR WRITTEN, OBTAINED BY YOU FROM NETPULSE OR THROUGH OR FROM        THE NETPULSE SERVICES OR SOFTWARE SHALL CREATE ANY WARRANTY NOT        EXPRESSLY STATED IN THESE TOS.</p></li>        <li><p>A SMALL PERCENTAGE OF USERS        MAY EXPERIENCE EPILEPTIC SEIZURES WHEN EXPOSED TO CERTAIN LIGHT        PATTERNS OR BACKGROUNDS ON A COMPUTER SCREEN OR WHILE USING THE        NETPULSE SERVICE. CERTAIN CONDITIONS MAY INDUCE PREVIOUSLY        UNDETECTED EPILEPTIC SYMPTOMS EVEN IN USERS WHO HAVE NO HISTORY OF        PRIOR SEIZURES OR EPILEPSY. IF YOU, OR ANYONE IN YOUR FAMILY, HAVE        AN EPILEPTIC CONDITION, CONSULT YOUR PHYSICIAN PRIOR TO USING THE        NETPULSE SERVICEs. IMMEDIATELY DISCONTINUE USE OF THE NETPULSE        SERVICES AND CONSULT YOUR PHYSICIAN IF YOU EXPERIENCE ANY OF THE        FOLLOWING SYMPTOMS WHILE USING THE NETPULSE SERVICE: DIZZINESS,        ALTERED VISION, EYE OR MUSCLE TWITCHES, LOSS OF AWARENESS,        DISORIENTATION, ANY INVOLUNTARY MOVEMENT, OR CONVULSIONS.</p></li>    </ol>    <li><p><b>Limitation of Liability</b></p></ol><p>YOU EXPRESSLY UNDERSTAND AND AGREE THAT NETPULSE AND ITS OFFICERS, EMPLOYEES, AGENTS, PARTNERS AND LICENSORS SHALL NOT BE LIABLE TO YOU FOR ANY PUNITIVE, INDIRECT, INCIDENTAL, SPECIAL, CONSEQUENTIAL OR EXEMPLARY DAMAGES, INCLUDING, BUT NOT LIMITED TO, DAMAGES FOR LOSS OF PROFITS, GOODWILL, USE, DATA OR OTHER INTANGIBLE LOSSES (EVEN IF NETPULSE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES), RESULTING FROM: (a) THE USE OR THE INABILITY TO USE THE NETPULSE SERVICE OR THE NETPULSE NETWORK; (b) THE COST OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES; (c) UNAUTHORIZED ACCESS TO OR ALTERATION OF YOUR TRANSMISSIONS OR DATA; (d) STATEMENTS OR CONDUCT OF ANY THIRD PARTY ON THE NETPULSE SERVICE; OR (e) ANY OTHER MATTER RELATING TO THE NETPULSE SERVICE.</p><ol start=14>    <li><p><b>Exceptions    to Disclaimers and Limitations</b></li>    </p></ol><p>SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF CERTAIN WARRANTIES OR THE LIMITATION OR EXCLUSION OF LIABILITY FOR INCIDENTAL OR CONSEQUENTIAL DAMAGES. ACCORDINGLY, SOME OF THE ABOVE LIMITATIONS OF SECTIONS 12 AND 13 MAY NOT APPLY TO YOU.</p><ol start=15>    <li><p>    <b>No Third-Party Beneficiaries</b></p></li></ol><p>You agree that, except as otherwise expressly provided in this TOS, there shall be no third-party beneficiaries to this agreement.</p><ol start=16>    <li><p><b>Notice</b></p></li></ol><p>Netpulse may provide you with notices, including those regarding changes to these TOS, including by but not limited to postings on the Netpulse Services, email, SMS, MMS, text message, regular mail or other reasonable means now known or hereafter developed. Such notices may not be received if you violate these TOS by accessing the Netpulse Services in an unauthorized manner. Your agreement to these TOS constitutes your agreement that you are deemed to have received any and all notices that would have been delivered had you accessed the Netpulse Services in an authorized manner.</p><ol start=17>    <li><p><b>General</b></p></li></ol><p><i>Entire Agreement</i>. These TOS constitutes the entire agreement between you and Netpulse and governs your use of the Netpulse Services, superseding any prior version of these TOS between you and Netpulse with respect to the Netpulse Services. You also may be subject to additional terms and conditions that may apply when you use or purchase certain other Netpulse services, affiliate services, third-party content or third-party software, or communicate with third parties such as advertisers</p><p><i>Choice of Law and Forum</i>. You and Netpulse each agree that these TOS and the relationship between the parties shall be governed by the laws of the State of California without regard to its conflict of law provisions and that any and all claims, causes of action or disputes (regardless of theory) arising out of or relating to these TOS, or the relationship between you and Netpulse, shall be brought exclusively in the courts located in the county of San Francisco, California or the U.S. District Court for the Northern District of California. You and Netpulse agree to submit to the personal jurisdiction of the courts located within the county of San Francisco, California or the Northern District of California, and agree to waive any and all objections to the exercise of jurisdiction over the parties by such courts and to venue in such courts.</p><p><i>Waiver and Severability of Terms</i>. The failure of Netpulse to exercise or enforce any right or provision of these TOS shall not constitute a waiver of such right or provision. If any provision of these TOS is found by a court of competent jurisdiction to be invalid, the parties nevertheless agree that the court should endeavor to give effect to the parties&rsquo; intentions as reflected in the provision, and the other provisions of these TOS remain in full force and effect.</p><p><i>No Right of Survivorship and Non-Transferability</i>. You agree that your Netpulse account is non-transferable and any rights to your Netpulse account or contents within your account terminate upon your death. Upon receipt of a copy of a death certificate, your account may be terminated and all contents therein permanently deleted.</p><p><i>Statute of Limitations</i>. You agree that regardless of any statute or law to the contrary, any claim or cause of action arising out of or related to use of the Netpulse Services or these TOS must be filed within one (1) year after such claim or cause of action arose or be forever barred.</p><p>The section titles in these TOS are for convenience only and have no legal or contractual effect.</p><ol start=18>    <li><p><b>Violations</b></p></li></ol><p>Please report any violations of these TOS to the Company at privacy@netpulse.com.</p><p><br /><br /></p><ol start=19>    <li><p><b>Procedure    for Making Claims of Infringement of Copyrights or other    Intellectual Property</b></p></li></ol><p>The Company respects the intellectual property of others, and asks users to do the same. If you believe that your work has been copied in a way that constitutes copyright infringement, or your intellectual property rights have been otherwise violated, please provide Netpulse with the following information:</p><ol>    <ol>        <li><p>an electronic        or physical signature of the person authorized to act on behalf of        the owner of the copyright or other intellectual property interest;</p></li>        <li><p>a description of the copyrighted        work or other intellectual property that you claim has been        infringed;</p></li>        <li><p>a description of where the        material that you claim is infringing is located through the        Netpulse Services;</p></li>        <li><p>your address, telephone number,        and email address;</p></li>        <li><p>a statement by you that you have        a good faith belief that the disputed use is not authorized by the        copyright owner, its agent, or the law;</p></li>        <li><p>a statement by you, made under        penalty of perjury, that the above information in your notice is        accurate and that you are the copyright or intellectual property        owner or authorized to act on the copyright or intellectual        property owner&rsquo;s behalf.</p></li>        <li><p>Notice        of claims of copyright or other intellectual property infringement        can be delivered as follows:</p></li>    </ol></ol><p>By mail:<br/>Netpulse, Inc.<br/>2331 Third Street<br/>San Francisco, CA 94107</p><p>By e-mail: <u>privacy@netpulse.com</u></p><h2>Privacy Policy</h2>Privacy Policy applies to all of the products, services and websites offered by Netpulse Inc. (&ldquo;Netpulse,&rdquo; the &ldquo;Company&rdquo;,&rdquo;we,&rdquo; and &ldquo;us,&rdquo; which terms shall include affiliates of Netpulse, Inc.). Please see also the Netpulse Terms of Service. Capitalized terms not otherwise defined in this Privacy Policy shall have the meaning set forth in the Terms of Service.<\/p> <h3>Information we collect and how we use it:<\/h3> <p>You may use some of the Netpulse Services without registration or providing any personal information to Netpulse. In order to provide the full personalized range of Netpulse Services, we may collect the following types of information:<\/p> <ul><li><b>Information you provide<\/b> &ndash; When you sign up for a Netpulse account or other Netpulse Service that requires registration, we may ask you for personal information (such as your name, gender, age, weight, height, other activity and physical data, email address, phone number) and an account password. We may combine the information you submit under your account with information provided through other Netpulse Services or third parties in order to provide you with a better experience and to improve the quality of our services. For certain services, we may give you the opportunity to opt out of combining such information. <\/li> <li> <b>Cookies<\/b> &mdash; When you visit the Site or use the Netpulse Services, we send one or more cookies &ndash; a small file containing a string of characters &ndash; to the device or other device that uniquely identifies you. We use cookies to improve the quality of the Netpulse Services, including for storing user preferences, and tracking user trends, such as how people use the product. Netpulse also uses cookies in its advertising services to help advertisers and publishers serve and manage ads across the Netpulse Network. <\/li> <li> <b>Log information<\/b> &ndash; When you access Netpulse Services, information generated during your session will be automatically recorded and stored on the Company&rsquo;s servers. These server logs may include information such as the webpages you visit, the content you access, the length and intensity of a workout tand the date and time of your request. <\/li> <li> <strong>Location data<\/strong> &ndash; The Company offers location-enabled services. If you use those services, Netpule may receive information about your actual location (such as the facility where you are working out and accessing the Netpulse Services). <\/li> <li> <strong>Links<\/strong> &ndash; We may present links in a format that enables us to keep track of whether these links have been followed. We use this information to improve the quality of our technology, customized content and advertising. <\/li> <li> <strong>Other sites<\/strong> &ndash; This Privacy Policy applies to Netpulse Services only. We do not exercise control over the sites displayed or linked to through the Netpulse Network or Netpulse Services. These other sites may place collect data or solicit personal information from you. <\/li><\/ul> <p>The Company only processes personal information for the purposes described in this Privacy Policy and/or the supplementary privacy notices for specific Netpulse Services. In addition to the above, such purposes include:<\/p> <h3>The display of customized content and advertising;<\/h3> <ul><li>Auditing, research and analysis in order to maintain, protect and improve the Netpulse Services and the use of exercise equipment;<\/li> <li>Ensuring the technical functioning of the Netpulse Network;<\/li> <li>Protecting the rights and property of Netpulse or our users; and<\/li> <li>Developing new services.<\/li><\/ul> <br /> <p>You acknowledge that in using the Netpulse Services you will be causing your personal information to be processed through Netpulse&rsquo;s computer networks, portions of which are located in California and other locations in the United States and portions of which may be located abroad. As a result, we process personal information on a server outside your own state/country. We may process personal information to provide the Netpulse Services, and also on behalf of and according to the instructions of a third party, such as our advertising partners and third-party content providers.<\/p> <h3>Choices for personal information<\/h3> <p>When you sign up for a particular service that requires registration, we ask you to provide personal information. You can decline to submit personal information to any of the Netpulse Services, in which case Netpulse may not be able to provide those services to you. As appropriate, we will offer you a way to opt out of the use of personal information for purposes. We will not collect or use sensitive information for purposes other than those described in this Privacy Policy and/or in the supplementary service privacy notices, unless we have obtained your prior consent. &ldquo;Sensitive personal information&rdquo; includes information we know to be related to confidential medical information, racial or ethnic origins, marital status and tied to personal information.<\/p> <h3>Information sharing<\/h3> <p>Netpulse may share your personal information with other companies or individuals outside of Netpulse in the following circumstances:<\/p> <ul><li> We have your consent.<\/li> <li> We provide such information to our subsidiaries, affiliated companies or other trusted businesses or persons for the purpose of processing personal information on our behalf. These parties are subject to appropriate confidentiality and security measures.<\/li> <li> We have a good faith belief that access, use, preservation or disclosure of such information is reasonably necessary to (a) satisfy any applicable law, regulation, legal process or enforceable governmental request, (b) enforce the Terms of Service, including investigation of potential violations thereof, (c) detect, prevent, or otherwise address fraud, security or technical issues, or (d) protect against harm to the rights, property or safety of Netpulse, its users or the public as required or permitted by law.<\/li><\/ul> <p>In addition, we use companies (Google and Yahoo!) and potentially others) to serve the advertisements on some of our pages. These companies and advertisers may place and access their cookies on your computer. Other companies&rsquo; use of their cookies is subject to their own privacy policies, not ours. We may use your information or allow advertisers or companies that serve advertisements access to your information to determine which advertisements you will see. This information may include your demographic information, geographic location, what content you access on our site, how you rate various content, language contained in your comments and other information.<\/p> <p>If Netpulse becomes involved in a merger, acquisition, or any form of sale of some or all of its assets, your personal information may be transferred in connection with such transaction, in which case we will use commercially reasonable efforts to ensure the confidentiality of any personal information involved in such transactions and provide notice when your personal information becomes subject to a different privacy policy.<\/p> <p>We may share with third parties certain pieces of aggregated, non-personal information, such as the number of users who viewed particular content, or the duration and intensity of a workout, for example. Such information does not identify you individually.<\/p> <p>Please contact us as provided below for any additional questions about the management or use of personal data.<\/p> <h3>Information security<\/h3> <p>We take appropriate security measures to protect against unauthorized access to or unauthorized alteration, disclosure or destruction of data. These include internal reviews of our data collection, storage and processing practices and security measures, as well as physical security measures to guard against unauthorized access to systems where we store personal data.<\/p> <p>We restrict access to personal information to Netpulse employees, contractors, agents and third parties who need to know that information in order to operate, develop or improve our services. These individuals are bound by appropriate confidentiality obligations.<\/p> <h3>Accessing and updating personal information<\/h3> <p>When you use the Netpulse Services, we make good faith efforts to provide you with access to your personal information and either to correct this data if it is inaccurate or to delete such data at your request if it is not otherwise required to be retained by law or for legitimate business purposes. We ask individual users to identify themselves and the information requested to be accessed, corrected or removed before processing such requests, and we may decline to process requests that are unreasonably repetitive or systematic, require disproportionate technical effort, jeopardize the privacy of others, or would be extremely impractical (for instance, requests concerning information residing on backup tapes), or for which access is not otherwise required.<\/p> <h3>Changes to this Privacy Policy: Please note that this Privacy Policy may change from time to time, and you should review it periodically.<\/h3> <h3>Questions: Please feel free to direct any questions or concerns regarding this Privacy Policy or Netpulse&rsquo;s treatment of personal information by contacting us through the Site or by writing to us at:<\/h3> <p> Privacy Matters<br>c/o Netpulse<br>2331 3rd Street<br>San Francisco, California, 94107 <\/p><strong>Johnson Health Tech. Co., Ltd. Privacy Policy<br/>Version 1.0 [4/8/13]</strong><p>This Privacy Policy applies to all of the services offered by Johnson Health Tech. Co., Ltd. (&quot;JHT,&quot; including its subsidiaries, affiliates, partners, predecessors, successors, assignors and assignees). This Privacy Policy expressly incorporates JHT's Terms of Service, with all capitalized terms not otherwise defined herein having the same meaning as set forth in the Terms of Service.</p><ol><li><strong>Collected Information</strong><p>JHT may collect the following types of information:</p><ul><li>Information you provide &mdash; When you sign up for a JHT account, JHT may ask you for personal information (such as your name, gender, age, weight, height, physical information, activity, contact information) and an account password. JHT may also ask for your account login and passwords associated with applications accessible via the JHT Services.</li><li>Activity information &mdash; When you access the JHT Services, information generated during sessions may be automatically recorded and stored on JHT's network. This may include applications used, websites visited, Content accessed, length and intensity of workout and date and time of workout.</li><li>Location data &mdash; JHT may offer location-enabled services. If you use these services, JHT may receive information about your location, such as the facility in which the JHT Services were accessed.</li><li>Links &mdash; JHT may present links in a format that enables JHT to track whether these links have been followed. JHT may use this information to improve the quality of the JHT Services, to customize content or for advertising purposes</li><li>Cookies &mdash; When accessing JHT's website, JHT may send one or more cookies (small data files transferred to your device's hard drive) to the device accessing the website.</li><li>Other applications and websites — This Privacy Policy applies to the JHT Services only. JHT does not exercise control over applications or websites displayed or linked through the JHT Services. These other applications or websites may collect date or solicit information from you.</li></ul><br/></li><li><strong>Use of Collected Information</strong><p>JHT processes personal information for the purposes described in this Privacy Policy and/or any supplementary privacy notices. Such purposes include:<p><ul><li>Allowing users to access applications via the JHT Services without having to submit additional log-in information each time these applications are accessed;</li><li>Display of customized content;</li><li>Storing user preferences;</li><li>Tracking how users utilize the JHT Services;</li><li>Reviewing, maintaining and improving the JHT Services and the use of exercise equipment;</li><li>Ensuring the technical functioning of the JHT network;</li><li>Protecting the rights and property of JHT or its users; and</li><li>Developing new services.</li></ul><p>You acknowledge that in using the JHT Services you will be causing your personal information to be processed through JHT's networks, portions of which are located in the United States and portions of which may be located abroad. You further acknowledge that JHT may share your personal information with affiliated entities under terms consistent with this Privacy Policy to accomplish the purposes outlined above.</p> </li><li><strong>Protection of Personal Information</strong><p>JHT will not collect or use sensitive personal information, such as information known to be confidential medical information, racial or ethnic origin or marital status tied to personal information, except as described in this Privacy Policy.</p></li><li><strong>Information Sharing by JHT</strong><p>JHT may share your personal information with other individuals or entities if: (a) JHT has your consent; (b) the information is used for the purpose of processing personal information on your behalf; or (c) JHT has a good faith belief that access to, use, preservation or disclosure of such information is reasonably necessary to (i) satisfy applicable law or respond to a valid legal request; (ii) enforce JHT's Terms of Service; (iii) address fraud, security or technical issues; or (iv) protect against harm to the rights, property or safety of JHT its users or the public.</p></li><li><strong>Use of Aggregated Information</strong><p>JHT may share with third parties aggregated, non-personal information, that does not identify the individuals from whom such data is collected.</p></li><li><strong>Information Collected by Third Parties</strong><p>JHT offers links to services offered by third parties. These third parties may collect information, including through the use of cookies, and are subject to the privacy policies maintained by such third parties.</p></li><li><strong>Information Shared with Advertisers</strong><p>JHT may use your personal information to allow advertisers or their agents to determine which advertisements you will see.</p></li><li><strong>Merger or Acquisition</strong><p>If JHT becomes involved in a merger, acquisition, or any form of sale of some or all of its assets, your personal information may be transferred to another entity.</p></li><li><strong>Changes to this Privacy Policy</strong><p>This Privacy Policy may change from time to time, and JHT may notify you by any of the means indicated in JHT's Terms of Service of such changes to this Privacy Policy.</p></li><li><strong>Questions and Further Concerns</strong><p>Please direct any questions concerning this Privacy Policy or JHT's treatment of personal information by contacting JHT at:</p><p>Director of Console Technology<br/>1600 Landmark Drive<br/>Cottage Grove, WI 53527.</p><p>Email inquiries may be sent to JHTconsoleservices@johnsonfit.com.</p>";

//startupVideo
IDS_LANGUAGE["continue"] = "계속";

