import QtQuick 1.0

// This code is not optimized, it's just an example where to put stuff in the build
Rectangle
{
    id: toggles
    width:  955
    height:  80
    x: 42
    y: 495
    color: "transparent"
    opacity: 1

    Image
    {
        id: factToggleContainer
        source: "../images/toggleBackground.png"
        height: 30
        width: 100

        Item
        {
            Rectangle
            {
                id: factToggle
                width: 15
                height: 15
                color: "blue"

                x: factToggleContainer.width - 25
                y: 7

                property bool toggled: false

                MouseArea
                {
                    anchors.fill: parent

                    onClicked:
                    {
                        if (factToggle.toggled)
                        {
                            factToggle.color = "blue";
                            factToggle.toggled = false;
                        }
                        else
                        {
                            factToggle.color = "red";
                            factToggle.toggled = true;
                        }
                    }
                }
            }

            Text
            {
                y: 5
                color: "white"
                text: "Facts"
            }
        }
    }


    Image
    {
        id: facebookToggleContainer
        source: "../images/toggleBackground.png"
        height: 30
        width: 100
        anchors.left: parent.right
        transform: Rotation { axis { x: 0; y: 1; z: 0 } angle: 180 }

        Image
        {
            id: facebookToggle
            source: "../images/facebook.png"
            width: 25
            height: 25
            property bool toggled: false
            y: 2
            x: facebookToggleContainer.width - 10

            transform: Rotation { axis { x: 0; y: 1; z: 0 } angle: 180 }

            MouseArea
            {
                anchors.fill: parent

                onClicked:
                {
                    if (facebookToggle.toggled)
                    {
                        facebookToggle.opacity = 1;
                        facebookToggle.toggled = false;
                    }
                    else
                    {
                        facebookToggle.opacity = 0.2;
                        facebookToggle.toggled = true;
                    }
                }
            }
        }
    }


    Image
    {
        id: profileToggleContainer
        source: "../images/toggleBackground.png"
        height: 30
        width: 100
        anchors.bottom: parent.bottom

        Item
        {
            Rectangle
            {
                id: profileToggle
                width: 15
                height: 15
                color: "green"

                x: profileToggleContainer.width - 25
                y: 7

                property bool toggled: false

                MouseArea
                {
                    anchors.fill: parent

                    onClicked:
                    {
                        if (profileToggle.toggled)
                        {
                            profileToggle.color = "green";
                            profileToggle.toggled = false;
                        }
                        else
                        {
                            profileToggle.color = "red";
                            profileToggle.toggled = true;
                        }
                    }
                }
            }

            Text
            {
                y: 5
                color: "white"
                text: "Profile"
            }
        }
    }


    Image
    {
        id: volumeToggleContainer
        source: "../images/toggleBackground.png"
        height: 30
        width: 100
        x: toggles.width
        anchors.bottom: parent.bottom
        property bool toggled: false

        transform: Rotation { axis { x: 0; y: 1; z: 0 } angle: 180 }

        MouseArea
        {
            anchors.fill: parent

            onClicked:
            {
                if (volumeToggleContainer.toggled)
                {
                    volumeToggleContainer.toggled = false;
                    volumeToggleContainer.x = toggles.width;   
                }
                else
                {
                    volumeToggleContainer.toggled = true;
                    volumeToggleContainer.x = toggles.width+70;
                }
            }
        }


        Behavior on x
        {
            NumberAnimation
            {
                id: bouncebehavior
                easing
                {
                    type: Easing.OutElastic
                    amplitude: 2.0
                    period: 0.2
                }
            }
        }

        Text
        {
            y: 5
            color: "green"
            text: "Volume"
            x: facebookToggleContainer.width - 10
            transform: Rotation { axis { x: 0; y: 1; z: 0 } angle: 180 }
        }
    }
}

